-----------------------------------
---   Waypoints - All in one!   ---
---     MULTI-STATE VERSION     ---
---        Update #9.5          ---
-----------------------------------
function RefreshMsg()
	if _toggleWaypointAIO2 > 0 then
		local xval = RenderSettings.resolution.x
		local yval = RenderSettings.resolution.y
		local txtsize = 10
		if xval >= 600 and xval < 800 then txtsize = 10 elseif xval >= 800 and xval < 1024 then txtsize = 15 elseif xval >= 1024 and xval < 1280 then txtsize = 20 elseif xval >= 1280 and xval < 1360 then txtsize = 25 elseif xval >= 1360 and xval < 1440 then txtsize = 30 elseif xval >= 1440 and xval < 1600 then txtsize = 35 elseif xval >= 1600 and xval < 1920 then txtsize = 40 elseif xval >= 1920 and xval < 2400 then	txtsize = 45 else txtsize = 40 end
		if not _HDmsg then
			_HDmsg = {}
			_HDmsg.ws = Overlay:newgui():create_screen_workspace()
			_HDmsg.lbl = _HDmsg.ws:panel():text{ name="lbl_1", x = -(RenderSettings.resolution.x / 2.1) + 0.5 * RenderSettings.resolution.x, y = -(RenderSettings.resolution.y / 4) + 6.1/9 * RenderSettings.resolution.y, text = "", font = tweak_data.menu.pd2_large_font, font_size = txtsize, color = Color.white:with_alpha(0.7), layer = 1 }
			_HDmsg.lbl2 = _HDmsg.ws:panel():text{ name="lbl_2", x = -(RenderSettings.resolution.x / 2.1) + 0.5 * RenderSettings.resolution.x, y = -(RenderSettings.resolution.y / 4) + 5.6/9 * RenderSettings.resolution.y, text = "Waypoint", font=tweak_data.menu.pd2_large_font, font_size = txtsize, color = Color.green:with_alpha(0.7), layer = 1 }
			_HDmsg.lbl:show()
			_HDmsg.lbl2:show()
		end
		local mess = ""
		if _toggleWaypointAIO2 == 1 then
			local unit_list = World:find_units_quick( "all" ) 
			local count = 0
			for _,unit in ipairs( unit_list ) do 
				if ( tostring(unit:name()) == "Idstring(@IDe8088e3bdae0ab9e@)" or	--Yellow Package
				tostring(unit:name()) == "Idstring(@ID05956ff396f3c58e@)" or		--Blue Package
				tostring(unit:name()) == "Idstring(@IDc90378ad89058c7d@)" or		--Purple Package
				tostring(unit:name()) == "Idstring(@ID96504ebd40f8cf98@)" or		--Red Package
				tostring(unit:name()) == "Idstring(@IDb3cc2abe1734636c@)" ) then 	--Green Package
					count = count + 1
			end	end
			mess = "[1/6] PACKAGE : "..tostring(count)
			_HDmsg.lbl:set_text(mess)
		elseif _toggleWaypointAIO2 == 2 then
			mess = "[2/6] KEYCARD/SECURITY DOOR"
			_HDmsg.lbl:set_text(mess)
		elseif _toggleWaypointAIO2 == 3 then
			mess = "[3/6] MONEY"
			_HDmsg.lbl:set_text(mess)
		elseif _toggleWaypointAIO2 == 4 then
			mess = "[4/6] PLANKS"
			_HDmsg.lbl:set_text(mess)
		elseif _toggleWaypointAIO2 == 5 then
			mess = "[5/6] CRATE/CROWBAR"
			_HDmsg.lbl:set_text(mess)
		elseif _toggleWaypointAIO2 == 6 then
			if managers.job:current_level_id() == "framing_frame_1" or managers.job:current_level_id() == "gallery" then
				mess = "[6/6] PAINTINGS" 
			elseif managers.job:current_level_id() == "framing_frame_3" then
				mess = "[6/6] INTEL" 
			elseif managers.job:current_level_id() == "alex_1" then
				mess = "[6/6] CHEMICAL" 
			elseif managers.job:current_level_id() == "alex_2" then
				mess = "[6/6] SAFE" 
			elseif managers.job:current_level_id() == "election_day_1" then
				mess = "[6/6] COMPUTER/TRUCK" 
			elseif managers.job:current_level_id() == "big" then
				mess = "[6/6] KEYBOARD/SERVER" 
			elseif managers.job:current_level_id() == "firestarter_2" then
				mess = "[6/6] SECURITY BOX" 
			elseif managers.job:current_level_id() == "welcome_to_the_jungle_1" then
				mess = "[6/6] INTEL" 
			elseif managers.job:current_level_id() == "kosugi" then
				mess = "[6/6] MANHOLE/ITEM" 
			elseif managers.job:current_level_id() == "welcome_to_the_jungle_2" then
				mess = "[6/6] ENGINE/SERVER ROOM" 
			elseif managers.job:current_level_id() == "arm_for" then
				mess = "[6/6] TURRET" 
			elseif managers.job:current_level_id() == "election_day_3_skip1" then
				mess = "[6/6] KEYBOARD" 
			elseif managers.job:current_level_id() == "ukrainian_job" then
				mess = "[6/6] POWER/TIARA" 
			elseif managers.job:current_level_id() == "mus" then
				mess = "[6/6] PATH/PICKUPS" 
			else
				mess = "[6/6] WAYPOINTS" 
			end
			_HDmsg.lbl:set_text(mess)
end	end	end
	
if inGame() and isPlaying() then
	if not _toggleWaypointAIO2 then _toggleWaypointAIO2 = 0 end
	_toggleWaypointAIO2 = _toggleWaypointAIO2 + 1	
	_keyboard_used = _keyboard_used or false
	_engine_used = _engine_used or false
	_intel_used = _intel_used or false
	bo_boxes = bo_boxes or {}
	SecBox1 = SecBox1 --or ""
	SecBox2 = SecBox2 --or ""
	_box1_used = _box1_used or false
	_box2_used = _box2_used or false
	_drill1_used = _drill1_used or false
	_drill2_used = _drill2_used or false
	_drill3_used = _drill3_used or false
	_tiara_used = _tiara_used or false
	_bbserv_used = _bbserv_used or false
	_FF1_msg = _FF1_msg or false
	_FF3_used = _FF3_used or false
	_gps_used = _gps_used or false
	_path_tile = _path_tile or 0
	_path_terminated = _path_terminated or false
	_hack_ok = _hack_ok or false
	_path_created = _path_created or 99999
	_script_activated = _script_activated or 0
	tabclk = tabclk or {}
	clientBox = clientBox or {}
	clientSucceed = clientSucceed or 0
	cm = managers.controller
	nb = nb or 0
	lp = lp or false
	_id_101277 = _id_101277 or false
	TrainHeistIntelSpawner_on = TrainHeistIntelSpawner_on or false
	if not _HDmsg then
		_HDmsg = {}
		_HDmsg.ws = Overlay:newgui():create_screen_workspace()
		local xval = RenderSettings.resolution.x
		local yval = RenderSettings.resolution.y
		local txtsize = 10
		if xval >= 600 and xval < 800 then txtsize = 10 elseif xval >= 800 and xval < 1024 then txtsize = 15 elseif xval >= 1024 and xval < 1280 then txtsize = 20 elseif xval >= 1280 and xval < 1360 then txtsize = 25 elseif xval >= 1360 and xval < 1440 then txtsize = 30 elseif xval >= 1440 and xval < 1600 then txtsize = 35 elseif xval >= 1600 and xval < 1920 then txtsize = 40 elseif xval >= 1920 and xval < 2400 then	txtsize = 45 else txtsize = 40 end
		_HDmsg.lbl = _HDmsg.ws:panel():text{ name="lbl_1", x = -(RenderSettings.resolution.x / 2.1) + 0.5 * RenderSettings.resolution.x, y = -(RenderSettings.resolution.y / 4) + 6.1/9 * RenderSettings.resolution.y, text = "", font = tweak_data.menu.pd2_large_font, font_size = txtsize, color = Color.white:with_alpha(0.7), layer = 1 }
		_HDmsg.lbl2 = _HDmsg.ws:panel():text{ name="lbl_2", x = -(RenderSettings.resolution.x / 2.1) + 0.5 * RenderSettings.resolution.x, y = -(RenderSettings.resolution.y / 4) + 5.6/9 * RenderSettings.resolution.y, text = "Waypoint", font=tweak_data.menu.pd2_large_font, font_size = txtsize, color = Color.green:with_alpha(0.7), layer = 1 }
		_HDmsg.lbl3 = _HDmsg.ws:panel():text{ name="lbl_3", x = -(RenderSettings.resolution.x / 2.1) + 0.5 * RenderSettings.resolution.x, y = -(RenderSettings.resolution.y / 4) + 6.6/9 * RenderSettings.resolution.y, text = "", font=tweak_data.menu.pd2_large_font, font_size = txtsize, color = Color.white:with_alpha(0.7), layer = 1 }
		_HDmsg.lbl4 = _HDmsg.ws:panel():text{ name="lbl_4", x = -(RenderSettings.resolution.x / 2.1) + 0.5 * RenderSettings.resolution.x, y = -(RenderSettings.resolution.y / 4) + 7.1/9 * RenderSettings.resolution.y, text = "", font=tweak_data.menu.pd2_large_font, font_size = txtsize, color = Color.red:with_alpha(0.7), layer = 1 }
		_HDmsg.lbl:show()
		_HDmsg.lbl2:show()
		_HDmsg.lbl3:show()
		_HDmsg.lbl4:show()
	end
		
	-- Framing Frame Day 1
	if managers.job:current_level_id() == 'framing_frame_1' or managers.job:current_level_id() == "gallery" then
		if _FF1_msg == false then
			local unit_list = World:find_units_quick( "all" ) 
			local count = 0
			for _,unit in ipairs( unit_list ) do 
				if unit:carry_data() then --or unit:base() then
					if (unit:interaction():active() == true) then
						count = count + 1
					end	
				end	
			end	
			if count == 9 then
				managers.chat:_receive_message(1, "Bain", "Guys, I have detected "..count.." paintings in the gallery. That's great. Maximum profits!", tweak_data.system_chat_color)
			elseif count == 8 then
				managers.chat:_receive_message(1, "Bain", "Guys, there are "..count.." paintings in the gallery.", tweak_data.system_chat_color)
			elseif count == 7 then
				managers.chat:_receive_message(1, "Bain", "Guys, "..count.." paintings are in the gallery. Not much compared with last time!", tweak_data.system_chat_color)
			elseif count == 6 or count < 6 then
				managers.chat:_receive_message(1, "Bain", "Guys, only "..count.." paintings detected in the gallery this time.. Better than nothing!", tweak_data.system_chat_color)
			end
			_FF1_msg = true
		end	
	end
			
	--speed up waypoint display
	managers.hud.__update_waypoints = managers.hud.__update_waypoints or managers.hud._update_waypoints 
	function HUDManager:_update_waypoints( t, dt ) 
		local result = self:__update_waypoints(t,dt) 
		for id,data in pairs( self._hud.waypoints ) do 
			id = tostring(id) 
			if id:sub(1,5) == 'hudz_' or id:sub(1,5) == 'hudb_' then 
				data.move_speed = 0.01
				data.bitmap:set_color( data.bitmap:color():with_alpha( 0.3 ) ) -- OPACITY : YOU CAN CHANGE THE VALUE (0-1)
				--data.distance:set_color( data.distance:color():with_alpha(0.3) ) -- /!\ The text may blink
                --data.arrow:set_color( data.arrow:color():with_alpha(0.3) )
			end	
		end 
		return result 
	end  
	
	function RefreshItemWaypoints()
		if inGame() and isPlaying() then
			Color.orange = Color("FF8500")

			for id,_ in pairs( clone( managers.hud._hud.waypoints ) ) do
				id = tostring(id)
				if id:sub(1,5) == 'hudz_' or id:sub(1,5) == 'hudb_' then
					managers.hud:remove_waypoint( id ) 
				end	
			end
			if _toggleWaypointAIO2 > 0 then
				local level = managers.job:current_level_id()
				for k,v in pairs(managers.interaction._interactive_objects) do
	------1---------
					if _toggleWaypointAIO2 == 1 then
						if v:interaction().tweak_data == 'gage_assignment' then
							 --[[Yellow]]
							if tostring(v:name()) == "Idstring(@IDe8088e3bdae0ab9e@)" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_christmas_present', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.yellow, blend_mode = "add" }  )
							 --[[Blue]]
							elseif tostring(v:name()) == "Idstring(@ID05956ff396f3c58e@)" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_christmas_present', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.blue, blend_mode = "add" }  )
							 --[[Purple]]
							elseif tostring(v:name()) == "Idstring(@IDc90378ad89058c7d@)" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_christmas_present', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.purple, blend_mode = "add" }  )
							--[[Red]] 
							elseif tostring(v:name()) == "Idstring(@ID96504ebd40f8cf98@)" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_christmas_present', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
							 --[[Green]]
							elseif tostring(v:name()) == "Idstring(@IDb3cc2abe1734636c@)" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_christmas_present', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
							else
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_christmas_present', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						end	end
	------2---------
					elseif _toggleWaypointAIO2 == 2 then
						-- CIV/COP with keycard
						for u_key,u_data in pairs(managers.enemy:all_civilians()) do
							local player_pos = managers.player:player_unit():camera():position()
							local unit_pos = u_data.unit:movement():m_head_pos()
							local vec = unit_pos - player_pos
							if isHost() and (u_data.unit.contour and alive(u_data.unit)) and u_data.unit:character_damage():pickup() then
								local cam_pos = managers.player:player_unit():camera():forward()
								local max_angle = 360
								local angle = vec:angle( cam_pos )	
								local ray = World:raycast("ray", player_pos, unit_pos, "slot_mask", managers.slot:get_mask( "AI_visibility" ), "ray_type", "ai_vision", "ignore_unit", { u_data.unit } )
								if (ray and ray.unit) then
									local cHealth = u_data.unit:character_damage() and u_data.unit:character_damage()._health
									if cHealth then
										local full = u_data.unit:character_damage()._HEALTH_INIT
										local supp = u_data.unit:character_damage()._suppression_data
										if full and (cHealth > 0) then 
											-- ALIVE
											managers.hud:add_waypoint( 'hudz_civ_'..tostring(unit_pos), { icon = 'equipment_bank_manager_key', distance = true, position = unit_pos, no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.orange, blend_mode = "add" }  )
										else
											-- DEAD
								end	end	end
								-- managers.hud:add_waypoint( 'hudz_civ_'..tostring(u_data), { icon = 'equipment_bank_manager_key', distance = true, position = unit_pos, no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.orange, blend_mode = "add" }  )
						end	end
						  
						for u_key, u_data in pairs(managers.enemy:all_enemies()) do
							local player_pos = managers.player:player_unit():camera():position()
							local unit_pos = u_data.unit:movement():m_head_pos()
							local vec = unit_pos - player_pos
							if isHost() and u_data.unit.contour and alive(u_data.unit) and u_data.unit:character_damage():pickup() and u_data.unit:character_damage():pickup() ~= "ammo" then
								local cam_pos = managers.player:player_unit():camera():forward()
								local max_angle = 360
								local angle = vec:angle( cam_pos )	
								local ray = World:raycast("ray", player_pos, unit_pos, "slot_mask", managers.slot:get_mask( "AI_visibility" ), "ray_type", "ai_vision", "ignore_unit", { u_data.unit } )
								if (ray and ray.unit) then
									local cHealth = u_data.unit:character_damage() and u_data.unit:character_damage()._health
									if cHealth then
										local full = u_data.unit:character_damage()._HEALTH_INIT
										local supp = u_data.unit:character_damage()._suppression_data
										if full and (cHealth > 0) then 
											-- ALIVE
											managers.hud:add_waypoint( 'hudz_cop_'..tostring(unit_pos), { icon = 'equipment_bank_manager_key', distance = true, position = unit_pos, no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.purple, blend_mode = "add" }  )
										else
											-- DEAD
								end	end	end
								-- managers.hud:add_waypoint( 'hudz_cop_'..tostring(u_data), { icon = 'equipment_bank_manager_key', distance = true, position = unit_pos, no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.purple, blend_mode = "add" }  )
						end	end
						
						if v:interaction().tweak_data == 'pickup_keycard' and v:position() ~= Vector3(3000, -3320, 949.99) and v:position() ~= Vector3(-1320, -3600, 400) and v:position() ~= Vector3(250, 6750, -64.2354) then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_bank_manager_key', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.yellow, blend_mode = "add" }  )
						-- BIG BANK KEYS
						elseif (v:interaction().tweak_data == 'invisible_interaction_open' or v:interaction().tweak_data == 'take_keys') and managers.job:current_level_id() == 'big' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_chavez_key', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.yellow, blend_mode = "add" }  )
						-- SECURITY DOOR V3
						elseif v:interaction().tweak_data == 'key' and managers.job:current_level_id() ~= "arm_for" then 
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_powerbutton', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
						--DIAMOND STORE KEYPAD
						elseif managers.job:current_level_id() == "family" and v:interaction().tweak_data == 'numpad_keycard' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_powerbutton', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
						end
						
						-- The Diamond
						if managers.job:current_level_id() == 'mus' then
							-- electric box
							if (v:interaction().tweak_data == 'invisible_interaction_open' or v:interaction().tweak_data == 'rewire_electric_box') and v:interaction():interact_position() ~= Vector3(6150, 549, -500) then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_powersupply', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.red, blend_mode = "add" }  )
							end
							-- security room - keyboard
							if v:interaction().tweak_data == 'hack_suburbia' or v:interaction().tweak_data == 'access_camera' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_powerbutton', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.orange, blend_mode = "add" }  )
							end
						end
	------3---------
					elseif _toggleWaypointAIO2 == 3 then
						-- WEAPONS
						if v:interaction().tweak_data == 'weapon_case' or v:interaction().tweak_data == 'take_weapons' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'ak', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.purple, blend_mode = "add" }  )
						-- COKE
						elseif v:interaction().tweak_data == 'gen_pku_cocaine' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_vial', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						-- MONEY
						elseif v:interaction().tweak_data == 'money_wrap_single_bundle' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("216C2A"), blend_mode = "add" }  )
						elseif v:interaction().tweak_data == 'cash_register' then
							if managers.job:current_level_id() == "jewelry_store" or managers.job:current_level_id() == "ukrainian_job" then
								if v:position() == Vector3(1844, 665, 117.732) then
								else
									managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("CCCCCC"), blend_mode = "add" }  )
								end 
							else
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("216C2A"), blend_mode = "add" }  )
							end
						elseif v:interaction().tweak_data == 'money_small' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("216C2A"), blend_mode = "add" }  )
						elseif v:interaction().tweak_data == 'money_wrap' then
							if managers.job:current_level_id() == "arm_for" then
								if v:position().z < -1320 then
									--
								else
									managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("216C2A"), blend_mode = "add" }  )
								end
							elseif managers.job:current_level_id() == "welcome_to_the_jungle_1" then
								if v:position() == Vector3(9200, -4300, 100) then
								else
									managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("216C2A"), blend_mode = "add" }  )
								end
							elseif managers.job:current_level_id() == "family" then
								if v:position() == Vector3(1400, 200, 1100) then
								else
									managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("216C2A"), blend_mode = "add" }  )
								end
							else
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("216C2A"), blend_mode = "add" }  )
							end	
						-- GOLD
						elseif v:interaction().tweak_data == 'gold_pile' then
							if managers.job:current_level_id() == "welcome_to_the_jungle_1" then
								if v:position() == Vector3(9200, -4400, 100) then
								else
									managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_gold', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("CC9900"), blend_mode = "add" }  )
								end
							else
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_gold', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("CC9900"), blend_mode = "add" }  )
							end
						-- DIAMONDS/JEWELS
						elseif v:interaction().tweak_data == 'diamond_pickup' or v:interaction().tweak_data == 'gen_pku_jewelry' then
							if managers.job:current_level_id() == "ukrainian_job" and v:position().z > 0 then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_diamond', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("B9F2FF"), blend_mode = "add" })
							elseif managers.job:current_level_id() ~= "ukrainian_job" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_diamond', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("B9F2FF"), blend_mode = "add" })
							end
						-- ATMS
						elseif v:interaction().tweak_data == 'requires_ecm_jammer_atm' then 
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_ecm_jammer', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.blue, blend_mode = "add" })
						-- SAFE LOOT
						elseif v:interaction().tweak_data == 'safe_loot_pickup' then 
							if managers.job:current_level_id() == "family" and v:position().z < 1000 then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("99CC32"), blend_mode = "add" })
							elseif managers.job:current_level_id() ~= "family" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("99CC32"), blend_mode = "add" })
							end
						end
						-- TRAIN HEIST AMMO
						if v:interaction().tweak_data == 'take_ammo' and managers.job:current_level_id() == "arm_for" then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_sentry', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.yellow, blend_mode = "add" })
						end	
						-- THE DIAMOND
						if managers.job:current_level_id() == 'mus' then
							if v:interaction().tweak_data == 'gen_pku_artifact' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_saw', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" })
							end					
							if v:interaction().tweak_data == 'mus_pku_artifact' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_money_wrap', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add"}  )
							end
							if v:interaction().tweak_data == 'gen_pku_artifact_painting' and v:interaction():interact_position() ~= Vector3(-2271.7534179688, -2397.224609375, -221.53845214844) and v:interaction():interact_position() ~= Vector3(-1425, -2260, -633.00500488281) then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_ticket', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" })
							end
						end						
	------4---------
					elseif _toggleWaypointAIO2 == 4 then
						-- PLANKS
						if v:interaction().tweak_data == 'stash_planks_pickup' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_planks', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("5C3317"), blend_mode = "add" }  )
						elseif v:interaction().tweak_data == 'pickup_boards' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_planks', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("5C3317"), blend_mode = "add" }  )
						end
	------5---------
					elseif _toggleWaypointAIO2 == 5 then
						-- CROWBAR
						if v:interaction().tweak_data == 'gen_pku_crowbar' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_crowbar', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						-- SHADOW RAID CRATES LOCATION
						elseif v:interaction().tweak_data == 'crate_loot_crowbar' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_lootdrop', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						-- ELECTION DAY 2 CRATES LOCATION
						elseif v:interaction().tweak_data == 'crate_loot' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_lootdrop', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						-- ELECTION DAY 2, MACHINES
						elseif v:interaction().tweak_data == 'votingmachine2' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_computer', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						end
	------6---------
					elseif _toggleWaypointAIO2 == 6 then
						-- THE DIAMOND - PUZZLE
						local _path_ok = _script_activated - _path_created
						if _path_ok > 0 then _hack_ok = true else _hack_ok = false end
						if managers.job:current_level_id() == 'mus' and v:interaction().tweak_data == 'mus_hold_open_display' and isHost() and _hack_ok == true then
							_path_terminated = false
							local tiles_all = {
								-- FLOOR
								["133577"] = Vector3(6475, 700, -600),	-- a001
								["133578"] = Vector3(6475, 500, -600),	-- a002
								["133579"] = Vector3(6475, 300, -600),	-- a003
								["133580"] = Vector3(6475, 100, -600),	-- a004
								["133581"] = Vector3(6475, -100, -600),	-- a005
								["133582"] = Vector3(6475, -300, -600),	-- a006
								-- A --
								["133583"] = Vector3(6675, 700, -600),	-- b001		UP
								["133584"] = Vector3(6675, 500, -600),	-- b002		UP
								["133585"] = Vector3(6675, 300, -600),	-- b003		UP
								["133586"] = Vector3(6675, 100, -600),	-- b004		UP
								["133587"] = Vector3(6675, -100, -600),	-- b005		UP
								["133588"] = Vector3(6675, -300, -600),	-- b006		UP
								-- B --
								-- b001 : 133631
								["133638"] = Vector3(6675, 500, -600),	-- b002		RIGHT
								["133589"] = Vector3(6875, 700, -600),	-- c001		UP
								-- b002 : 133633
								["133640"] = Vector3(6675, 300, -600),	-- b003		RIGHT
								["133590"] = Vector3(6675, 300, -600),	-- c002		UP
								["133639"] = Vector3(6675, 700, -600),	-- b001		LEFT
								-- b003 : 133634
								["133591"] = Vector3(6875, 300, -600),	-- c003		UP
								["133642"] = Vector3(6675, 100, -600),	-- b004		RIGHT
								["133641"] = Vector3(6675, 500, -600),	-- b002		LEFT
								-- b004 : 133635
								["133592"] = Vector3(6875, 100, -600),	-- c004		UP
								["133643"] = Vector3(6675, 300, -600),	-- b003		LEFT
								["133645"] = Vector3(6675, -100, -600),	-- b005		RIGHT
								-- b005 : 133636
								["133593"] = Vector3(6875, -100, -600),	-- c005		UP
								["133647"] = Vector3(6675, -300, -600),	-- b006		RIGHT
								["133644"] = Vector3(6675, 100, -600),	-- b004		LEFT
								-- b006 : 133637
								["133594"] = Vector3(6875, -300, -600),	-- c005		UP
								["133646"] = Vector3(6675, -100, -600),	-- b005		LEFT
								-- C --
								-- c001 : 133650
								["133595"] = Vector3(7075, 700, -600),	-- d001		UP
								["133648"] = Vector3(6875, 500, -600),	-- c002		RIGHT
								-- c002 : 133653
								["133601"] = Vector3(7075, 500, -600),	-- d002		UP
								["133652"] = Vector3(6875, 300, -600),	-- c003		RIGHT
								["133649"] = Vector3(6875, 700, -600),	-- c001		LEFT
								-- c003 : 133656
								["133607"] = Vector3(7075, 300, -600),	-- d003		UP
								["133655"] = Vector3(6875, 100, -600),	-- c004		RIGHT
								["133651"] = Vector3(6875, 500, -600),	-- c002		LEFT
								-- c004 : 133659
								["133613"] = Vector3(7075, 100, -600),	-- d004		UP
								["133658"] = Vector3(6875, -100, -600),	-- c005		RIGHT
								["133654"] = Vector3(6875, 300, -600),	-- c003		LEFT
								-- c005 : 133662
								["133619"] = Vector3(7075, -100, -600),	-- d005		UP
								["133661"] = Vector3(6875, -300, -600),	-- c006		RIGHT
								["133657"] = Vector3(6875, 100, -600),	-- c004		LEFT
								-- c006 : 133663
								["133625"] = Vector3(7075, -300, -600),	-- d006		UP
								["133660"] = Vector3(6875, -100, -600),	-- c005		LEFT
								-- D --
								-- d001 : 133666
								["133596"] = Vector3(7275, 700, -600),	-- e001		UP
								["133664"] = Vector3(7075, 500, -600),	-- d002		RIGHT
								-- d002 : 133669
								["133602"] = Vector3(7275, 500, -600),	-- e002		UP
								["133667"] = Vector3(7075, 300, -600),	-- d003		RIGHT
								["133665"] = Vector3(7075, 700, -600),	-- d001		LEFT
								-- d003 : 133672
								["133608"] = Vector3(7275, 300, -600),	-- e003		UP
								["133670"] = Vector3(7075, 100, -600),	-- d004		RIGHT
								["133668"] = Vector3(7075, 500, -600),	-- d002		LEFT
								-- d004 : 133675
								["133614"] = Vector3(7275, 100, -600),	-- e004		UP
								["133673"] = Vector3(7075, -100, -600),	-- d005		RIGHT
								["133671"] = Vector3(7075, 300, -600),	-- d003		LEFT
								-- d005 : 133678
								["133620"] = Vector3(7275, -100, -600),	-- e005		UP
								["133676"] = Vector3(7075, -300, -600),	-- d006		RIGHT
								["133674"] = Vector3(7075, 100, -600),	-- d004		LEFT
								-- d006 : 133679
								["133626"] = Vector3(7275, -300, -600),	-- e006		UP
								["133677"] = Vector3(7075, -100, -600),	-- d005		LEFT
								-- E --
								-- e001 : 133680
								["133597"] = Vector3(7475, 700, -600),	-- f001		UP
								["133682"] = Vector3(7275, 500, -600),	-- e002		RIGHT
								-- e002 : 133683
								["133603"] = Vector3(7475, 500, -600),	-- f002		UP
								["133684"] = Vector3(7275, 300, -600),	-- e003		RIGHT
								["133681"] = Vector3(7275, 700, -600),	-- e001		LEFT
								-- e003 : 133686
								["133609"] = Vector3(7475, 300, -600),	-- f003		UP
								["133687"] = Vector3(7275, 100, -600),	-- e004		RIGHT
								["133685"] = Vector3(7275, 500, -600),	-- e002		LEFT
								-- e004 : 133689
								["133615"] = Vector3(7475, 100, -600),	-- f004		UP
								["133690"] = Vector3(7275, -100, -600),	-- e005		RIGHT
								["133688"] = Vector3(7275, 300, -600),	-- e003		LEFT
								-- e005 : 133692
								["133621"] = Vector3(7475, -100, -600),	-- f005		UP
								["133693"] = Vector3(7275, -300, -600),	-- e006		RIGHT
								["133691"] = Vector3(7275, 100, -600),	-- e004		LEFT
								-- e006 : 133695
								["133627"] = Vector3(7475, -300, -600),	-- f006		UP
								["133694"] = Vector3(7275, -100, -600),	-- e005		LEFT
								-- F --
								-- f001 : 133696
								["133598"] = Vector3(7675, 700, -600),	-- g001		UP
								["133698"] = Vector3(7475, 500, -600),	-- f002		RIGHT
								-- f002 : 133699
								["133604"] = Vector3(7675, 500, -600),	-- g002		UP
								["133700"] = Vector3(7475, 300, -600),	-- f003		RIGHT
								["133697"] = Vector3(7475, 700, -600),	-- f001		LEFT
								-- f003 : 133702
								["133610"] = Vector3(7675, 300, -600),	-- g003		UP
								["133703"] = Vector3(7475, 100, -600),	-- f004		RIGHT
								["133701"] = Vector3(7475, 500, -600),	-- f002		LEFT
								-- f004 : 133705
								["133616"] = Vector3(7675, 100, -600),	-- g004		UP
								["133706"] = Vector3(7475, -100, -600),	-- f005		RIGHT
								["133704"] = Vector3(7475, 300, -600),	-- f003		LEFT
								-- f005 : 133708
								["133622"] = Vector3(7675, -100, -600),	-- g005		UP
								["133709"] = Vector3(7475, -300, -600),	-- f006		RIGHT
								["133707"] = Vector3(7475, 100, -600),	-- f004		LEFT
								-- f006 : 133711
								["133628"] = Vector3(7675, -300, -600),	-- g006		UP
								["133710"] = Vector3(7475, -100, -600),	-- f005		LEFT
						-- G --
								-- g001 : 133712
								["133599"] = Vector3(7875, 700, -600),	-- h001		UP
								["133714"] = Vector3(7675, 500, -600),	-- g002		RIGHT
								-- g002 : 133715
								["133605"] = Vector3(7875, 500, -600),	-- h002		UP
								["133716"] = Vector3(7675, 300, -600),	-- g003		RIGHT
								["133713"] = Vector3(7675, 700, -600),	-- g001		LEFT
								-- g003 : 133718
								["133611"] = Vector3(7875, 300, -600),	-- h003		UP
								["133719"] = Vector3(7675, 100, -600),	-- g004		RIGHT
								["133717"] = Vector3(7675, 500, -600),	-- g002		LEFT
								-- g004 : 133721
								["133617"] = Vector3(7875, 100, -600),	-- h004		UP
								["133722"] = Vector3(7675, -100, -600),	-- g005		RIGHT
								["133720"] = Vector3(7675, 300, -600),	-- g003		LEFT
								-- g005 : 133724
								["133623"] = Vector3(7875, -100, -600),	-- h005		UP
								["133725"] = Vector3(7675, -300, -600),	-- g006		RIGHT
								["133723"] = Vector3(7675, 100, -600),	-- g004		LEFT
								-- g006 : 133727
								["133629"] = Vector3(7875, -300, -600),	-- h006		UP
								["133726"] = Vector3(7675, -100, -600),	-- g005		LEFT
						-- H --
								-- h001 : 133728
								["133600"] = Vector3(8075, 700, -600),	-- i001		UP
								["133730"] = Vector3(7875, 500, -600),	-- h002		RIGHT
								-- h002 : 133731
								["133606"] = Vector3(8075, 500, -600),	-- i002		UP
								["133732"] = Vector3(7875, 300, -600),	-- h003		RIGHT
								["133729"] = Vector3(7875, 700, -600),	-- h001		LEFT
								-- h003 : 133734
								["133612"] = Vector3(8075, 300, -600),	-- i003		UP
								["133735"] = Vector3(7875, 100, -600),	-- h004		RIGHT
								["133733"] = Vector3(7875, 500, -600),	-- h002		LEFT
								-- h004 : 133737
								["133618"] = Vector3(8075, 100, -600),	-- i004		UP
								["133738"] = Vector3(7875, -100, -600),	-- h005		RIGHT
								["133736"] = Vector3(7875, 300, -600),	-- h003		LEFT
								-- h005 : 133740
								["133624"] = Vector3(8075, -100, -600),	-- i005		UP
								["133741"] = Vector3(7875, -300, -600),	-- h006		RIGHT
								["133739"] = Vector3(7875, 100, -600),	-- h004		LEFT
								-- h006 : 133743
								["133630"] = Vector3(8075, -300, -600),	-- i006		UP
								["133742"] = Vector3(7875, -100, -600),	-- h005		LEFT
							}
								
							if _path_terminated == false then
								if _path_ok > 1 then
									local tile_1 = managers.mission:script("default")._elements[133576]._values.on_executed[1].id
									managers.hud:add_waypoint( 'hudz_'..'tile_1', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_1)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
									if _path_ok > 2 then
										local tile_2 = managers.mission:script("default")._elements[tile_1]._values.on_executed[1].id
										managers.hud:add_waypoint( 'hudz_'..'tile_2', {icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_2)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										if _path_ok > 3 then
											local tile_3 = managers.mission:script("default")._elements[tile_2]._values.on_executed[1].id
											local tile_3b = managers.mission:script("default")._elements[tile_3]._values.on_executed[1].id
											if tile_3 == 133631 or tile_3 == 133633	or tile_3 == 133634 or tile_3 == 133635 or tile_3 == 133636 or tile_3 == 133637 or tile_3 == 133650 
											or tile_3 == 133653 or tile_3 == 133656 or tile_3 == 133659 or tile_3 == 133662 or tile_3 == 133663 or tile_3 == 133666 or tile_3 == 133669 
											or tile_3 == 133672 or tile_3 == 133675 or tile_3 == 133678 or tile_3 == 133679 or tile_3 == 133680 or tile_3 == 133683 or tile_3 == 133686 
											or tile_3 == 133689 or tile_3 == 133692 or tile_3 == 133695 or tile_3 == 133696 or tile_3 == 133699 or tile_3 == 133702 or tile_3 == 133705 
											or tile_3 == 133708 or tile_3 == 133711 or tile_3 == 133712 or tile_3 == 133715 or tile_3 == 133718 or tile_3 == 133721 or tile_3 == 133724 
											or tile_3 == 133727 or tile_3 == 133728 or tile_3 == 133731 or tile_3 == 133734 or tile_3 == 133737 or tile_3 == 133740 or tile_3 == 133743 then
												managers.hud:add_waypoint( 'hudz_'..'tile_3', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_3b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
												_path_tile = tile_3b
											else
												managers.hud:add_waypoint( 'hudz_'..'tile_3', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_3)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
												_path_tile = tile_3
											end
											if _path_ok > 4 then
												local tile_4_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
												local tile_4 = managers.mission:script("default")._elements[tile_4_0]._values.on_executed[1].id
												local tile_4b = managers.mission:script("default")._elements[tile_4]._values.on_executed[1].id
												if tile_4 == 133631 or tile_4 == 133633	or tile_4 == 133634 or tile_4 == 133635 or tile_4 == 133636 or tile_4 == 133637 or tile_4 == 133650 
												or tile_4 == 133653 or tile_4 == 133656 or tile_4 == 133659 or tile_4 == 133662 or tile_4 == 133663 or tile_4 == 133666 or tile_4 == 133669 
												or tile_4 == 133672 or tile_4 == 133675 or tile_4 == 133678 or tile_4 == 133679 or tile_4 == 133680 or tile_4 == 133683 or tile_4 == 133686 
												or tile_4 == 133689 or tile_4 == 133692 or tile_4 == 133695 or tile_4 == 133696 or tile_4 == 133699 or tile_4 == 133702 or tile_4 == 133705 
												or tile_4 == 133708 or tile_4 == 133711 or tile_4 == 133712 or tile_4 == 133715 or tile_4 == 133718 or tile_4 == 133721 or tile_4 == 133724 
												or tile_4 == 133727 or tile_4 == 133728 or tile_4 == 133731 or tile_4 == 133734 or tile_4 == 133737 or tile_4 == 133740 or tile_4 == 133743 then
													managers.hud:add_waypoint( 'hudz_'..'tile_4', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_4b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
													_path_tile = tile_4b
												else
													managers.hud:add_waypoint( 'hudz_'..'tile_4', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_4)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
													_path_tile = tile_4
												end
												if _path_ok > 5 then
													local tile_5_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
													local tile_5 = managers.mission:script("default")._elements[tile_5_0]._values.on_executed[1].id
													local tile_5b = managers.mission:script("default")._elements[tile_5]._values.on_executed[1].id
													if tile_5 == 133631 or tile_5 == 133633	or tile_5 == 133634 or tile_5 == 133635 or tile_5 == 133636 or tile_5 == 133637 or tile_5 == 133650 
													or tile_5 == 133653 or tile_5 == 133656 or tile_5 == 133659 or tile_5 == 133662 or tile_5 == 133663 or tile_5 == 133666 or tile_5 == 133669 
													or tile_5 == 133672 or tile_5 == 133675 or tile_5 == 133678 or tile_5 == 133679 or tile_5 == 133680 or tile_5 == 133683 or tile_5 == 133686 
													or tile_5 == 133689 or tile_5 == 133692 or tile_5 == 133695 or tile_5 == 133696 or tile_5 == 133699 or tile_5 == 133702 or tile_5 == 133705 
													or tile_5 == 133708 or tile_5 == 133711 or tile_5 == 133712 or tile_5 == 133715 or tile_5 == 133718 or tile_5 == 133721 or tile_5 == 133724 
													or tile_5 == 133727 or tile_5 == 133728 or tile_5 == 133731 or tile_5 == 133734 or tile_5 == 133737 or tile_5 == 133740 or tile_5 == 133743 then
														managers.hud:add_waypoint( 'hudz_'..'tile_5', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_5b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
														_path_tile = tile_5b
													else
														managers.hud:add_waypoint( 'hudz_'..'tile_5', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_5)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
														_path_tile = tile_5
													end
													if _path_ok > 6 then
														local tile_6_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
														local tile_6 = managers.mission:script("default")._elements[tile_6_0]._values.on_executed[1].id
														local tile_6b = managers.mission:script("default")._elements[tile_6]._values.on_executed[1].id
														if tile_6 == 133631 or tile_6 == 133633	or tile_6 == 133634 or tile_6 == 133635 or tile_6 == 133636 or tile_6 == 133637 or tile_6 == 133650 
														or tile_6 == 133653 or tile_6 == 133656 or tile_6 == 133659 or tile_6 == 133662 or tile_6 == 133663 or tile_6 == 133666 or tile_6 == 133669 
														or tile_6 == 133672 or tile_6 == 133675 or tile_6 == 133678 or tile_6 == 133679 or tile_6 == 133680 or tile_6 == 133683 or tile_6 == 133686 
														or tile_6 == 133689 or tile_6 == 133692 or tile_6 == 133695 or tile_6 == 133696 or tile_6 == 133699 or tile_6 == 133702 or tile_6 == 133705 
														or tile_6 == 133708 or tile_6 == 133711 or tile_6 == 133712 or tile_6 == 133715 or tile_6 == 133718 or tile_6 == 133721 or tile_6 == 133724 
														or tile_6 == 133727 or tile_6 == 133728 or tile_6 == 133731 or tile_6 == 133734 or tile_6 == 133737 or tile_6 == 133740 or tile_6 == 133743 then
															managers.hud:add_waypoint( 'hudz_'..'tile_6', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_6b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
															_path_tile = tile_6b
														else
															managers.hud:add_waypoint( 'hudz_'..'tile_6', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_6)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
															_path_tile = tile_6
														end
														if _path_ok > 7 then
															local tile_7_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
															local tile_7 = managers.mission:script("default")._elements[tile_7_0]._values.on_executed[1].id
															local tile_7b = managers.mission:script("default")._elements[tile_7]._values.on_executed[1].id
															if tile_7 == 133631 or tile_7 == 133633	or tile_7 == 133634 or tile_7 == 133635 or tile_7 == 133636 or tile_7 == 133637 or tile_7 == 133650 
															or tile_7 == 133653 or tile_7 == 133656 or tile_7 == 133659 or tile_7 == 133662 or tile_7 == 133663 or tile_7 == 133666 or tile_7 == 133669 
															or tile_7 == 133672 or tile_7 == 133675 or tile_7 == 133678 or tile_7 == 133679 or tile_7 == 133680 or tile_7 == 133683 or tile_7 == 133686 
															or tile_7 == 133689 or tile_7 == 133692 or tile_7 == 133695 or tile_7 == 133696 or tile_7 == 133699 or tile_7 == 133702 or tile_7 == 133705 
															or tile_7 == 133708 or tile_7 == 133711 or tile_7 == 133712 or tile_7 == 133715 or tile_7 == 133718 or tile_7 == 133721 or tile_7 == 133724 
															or tile_7 == 133727 or tile_7 == 133728 or tile_7 == 133731 or tile_7 == 133734 or tile_7 == 133737 or tile_7 == 133740 or tile_7 == 133743 then
																managers.hud:add_waypoint( 'hudz_'..'tile_7', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_7b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
																_path_tile = tile_7b
															else
																managers.hud:add_waypoint( 'hudz_'..'tile_7', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_7)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
																_path_tile = tile_7
															end
															if _path_ok > 8 then
																local tile_8_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
																local tile_8 = managers.mission:script("default")._elements[tile_8_0]._values.on_executed[1].id
																local tile_8b = managers.mission:script("default")._elements[tile_8]._values.on_executed[1].id
																if tile_8 == 133631 or tile_8 == 133633	or tile_8 == 133634 or tile_8 == 133635 or tile_8 == 133636 or tile_8 == 133637 or tile_8 == 133650 
																or tile_8 == 133653 or tile_8 == 133656 or tile_8 == 133659 or tile_8 == 133662 or tile_8 == 133663 or tile_8 == 133666 or tile_8 == 133669 
																or tile_8 == 133672 or tile_8 == 133675 or tile_8 == 133678 or tile_8 == 133679 or tile_8 == 133680 or tile_8 == 133683 or tile_8 == 133686 
																or tile_8 == 133689 or tile_8 == 133692 or tile_8 == 133695 or tile_8 == 133696 or tile_8 == 133699 or tile_8 == 133702 or tile_8 == 133705 
																or tile_8 == 133708 or tile_8 == 133711 or tile_8 == 133712 or tile_8 == 133715 or tile_8 == 133718 or tile_8 == 133721 or tile_8 == 133724 
																or tile_8 == 133727 or tile_8 == 133728 or tile_8 == 133731 or tile_8 == 133734 or tile_8 == 133737 or tile_8 == 133740 or tile_8 == 133743 then
																	managers.hud:add_waypoint( 'hudz_'..'tile_8', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_8b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
																	_path_tile = tile_8b
																else
																	managers.hud:add_waypoint( 'hudz_'..'tile_8', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_8)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
																	_path_tile = tile_8
																end
																if _path_ok > 9 then
																	local tile_9_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
																	local tile_9 = managers.mission:script("default")._elements[tile_9_0]._values.on_executed[1].id
																	local tile_9b = managers.mission:script("default")._elements[tile_9]._values.on_executed[1].id
																	if tile_9 == 133631 or tile_9 == 133633	or tile_9 == 133634 or tile_9 == 133635 or tile_9 == 133636 or tile_9 == 133637 or tile_9 == 133650 
																	or tile_9 == 133653 or tile_9 == 133656 or tile_9 == 133659 or tile_9 == 133662 or tile_9 == 133663 or tile_9 == 133666 or tile_9 == 133669 
																	or tile_9 == 133672 or tile_9 == 133675 or tile_9 == 133678 or tile_9 == 133679 or tile_9 == 133680 or tile_9 == 133683 or tile_9 == 133686 
																	or tile_9 == 133689 or tile_9 == 133692 or tile_9 == 133695 or tile_9 == 133696 or tile_9 == 133699 or tile_9 == 133702 or tile_9 == 133705 
																	or tile_9 == 133708 or tile_9 == 133711 or tile_9 == 133712 or tile_9 == 133715 or tile_9 == 133718 or tile_9 == 133721 or tile_9 == 133724 
																	or tile_9 == 133727 or tile_9 == 133728 or tile_9 == 133731 or tile_9 == 133734 or tile_9 == 133737 or tile_9 == 133740 or tile_9 == 133743 then
																		managers.hud:add_waypoint( 'hudz_'..'tile_9', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_9b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
																		_path_tile = tile_9b
																	else
																		managers.hud:add_waypoint( 'hudz_'..'tile_9', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_9)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
																		_path_tile = tile_9
																	end
																	if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
																		-- LAST TILE!
																		_path_terminated = true
																	end
																end 
															end 
														end 
													end 
												end 
											end 
										end 
									end 
								end
							end
							if _path_ok > 10 then
								if _path_terminated == false then
									local tile_10_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_10 = managers.mission:script("default")._elements[tile_10_0]._values.on_executed[1].id
									local tile_10b = managers.mission:script("default")._elements[tile_10]._values.on_executed[1].id
									if tile_10 == 133631 or tile_10 == 133633	or tile_10 == 133634 or tile_10 == 133635 or tile_10 == 133636 or tile_10 == 133637 or tile_10 == 133650 
									or tile_10 == 133653 or tile_10 == 133656 or tile_10 == 133659 or tile_10 == 133662 or tile_10 == 133663 or tile_10 == 133666 or tile_10 == 133669 
									or tile_10 == 133672 or tile_10 == 133675 or tile_10 == 133678 or tile_10 == 133679 or tile_10 == 133680 or tile_10 == 133683 or tile_10 == 133686 
									or tile_10 == 133689 or tile_10 == 133692 or tile_10 == 133695 or tile_10 == 133696 or tile_10 == 133699 or tile_10 == 133702 or tile_10 == 133705 
									or tile_10 == 133708 or tile_10 == 133711 or tile_10 == 133712 or tile_10 == 133715 or tile_10 == 133718 or tile_10 == 133721 or tile_10 == 133724 
									or tile_10 == 133727 or tile_10 == 133728 or tile_10 == 133731 or tile_10 == 133734 or tile_10 == 133737 or tile_10 == 133740 or tile_10 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_10', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_10b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_10b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_10', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_10)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_10
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_11_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_11 = managers.mission:script("default")._elements[tile_11_0]._values.on_executed[1].id
									local tile_11b = managers.mission:script("default")._elements[tile_11]._values.on_executed[1].id
									if tile_11 == 133631 or tile_11 == 133633	or tile_11 == 133634 or tile_11 == 133635 or tile_11 == 133636 or tile_11 == 133637 or tile_11 == 133650 
									or tile_11 == 133653 or tile_11 == 133656 or tile_11 == 133659 or tile_11 == 133662 or tile_11 == 133663 or tile_11 == 133666 or tile_11 == 133669 
									or tile_11 == 133672 or tile_11 == 133675 or tile_11 == 133678 or tile_11 == 133679 or tile_11 == 133680 or tile_11 == 133683 or tile_11 == 133686 
									or tile_11 == 133689 or tile_11 == 133692 or tile_11 == 133695 or tile_11 == 133696 or tile_11 == 133699 or tile_11 == 133702 or tile_11 == 133705 
									or tile_11 == 133708 or tile_11 == 133711 or tile_11 == 133712 or tile_11 == 133715 or tile_11 == 133718 or tile_11 == 133721 or tile_11 == 133724 
									or tile_11 == 133727 or tile_11 == 133728 or tile_11 == 133731 or tile_11 == 133734 or tile_11 == 133737 or tile_11 == 133740 or tile_11 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_11', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_11b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_11b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_11', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_11)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_11
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_12_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_12 = managers.mission:script("default")._elements[tile_12_0]._values.on_executed[1].id
									local tile_12b = managers.mission:script("default")._elements[tile_12]._values.on_executed[1].id
									if tile_12 == 133631 or tile_12 == 133633	or tile_12 == 133634 or tile_12 == 133635 or tile_12 == 133636 or tile_12 == 133637 or tile_12 == 133650 
									or tile_12 == 133653 or tile_12 == 133656 or tile_12 == 133659 or tile_12 == 133662 or tile_12 == 133663 or tile_12 == 133666 or tile_12 == 133669 
									or tile_12 == 133672 or tile_12 == 133675 or tile_12 == 133678 or tile_12 == 133679 or tile_12 == 133680 or tile_12 == 133683 or tile_12 == 133686 
									or tile_12 == 133689 or tile_12 == 133692 or tile_12 == 133695 or tile_12 == 133696 or tile_12 == 133699 or tile_12 == 133702 or tile_12 == 133705 
									or tile_12 == 133708 or tile_12 == 133711 or tile_12 == 133712 or tile_12 == 133715 or tile_12 == 133718 or tile_12 == 133721 or tile_12 == 133724 
									or tile_12 == 133727 or tile_12 == 133728 or tile_12 == 133731 or tile_12 == 133734 or tile_12 == 133737 or tile_12 == 133740 or tile_12 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_12', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_12b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_12b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_12', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_12)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_12
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_13_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_13 = managers.mission:script("default")._elements[tile_13_0]._values.on_executed[1].id
									local tile_13b = managers.mission:script("default")._elements[tile_13]._values.on_executed[1].id
									if tile_13 == 133631 or tile_13 == 133633	or tile_13 == 133634 or tile_13 == 133635 or tile_13 == 133636 or tile_13 == 133637 or tile_13 == 133650 
									or tile_13 == 133653 or tile_13 == 133656 or tile_13 == 133659 or tile_13 == 133662 or tile_13 == 133663 or tile_13 == 133666 or tile_13 == 133669 
									or tile_13 == 133672 or tile_13 == 133675 or tile_13 == 133678 or tile_13 == 133679 or tile_13 == 133680 or tile_13 == 133683 or tile_13 == 133686 
									or tile_13 == 133689 or tile_13 == 133692 or tile_13 == 133695 or tile_13 == 133696 or tile_13 == 133699 or tile_13 == 133702 or tile_13 == 133705 
									or tile_13 == 133708 or tile_13 == 133711 or tile_13 == 133712 or tile_13 == 133715 or tile_13 == 133718 or tile_13 == 133721 or tile_13 == 133724 
									or tile_13 == 133727 or tile_13 == 133728 or tile_13 == 133731 or tile_13 == 133734 or tile_13 == 133737 or tile_13 == 133740 or tile_13 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_13', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_13b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_13b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_13', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_13)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_13
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_14_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_14 = managers.mission:script("default")._elements[tile_14_0]._values.on_executed[1].id
									local tile_14b = managers.mission:script("default")._elements[tile_14]._values.on_executed[1].id
									if tile_14 == 133631 or tile_14 == 133633	or tile_14 == 133634 or tile_14 == 133635 or tile_14 == 133636 or tile_14 == 133637 or tile_14 == 133650 
									or tile_14 == 133653 or tile_14 == 133656 or tile_14 == 133659 or tile_14 == 133662 or tile_14 == 133663 or tile_14 == 133666 or tile_14 == 133669 
									or tile_14 == 133672 or tile_14 == 133675 or tile_14 == 133678 or tile_14 == 133679 or tile_14 == 133680 or tile_14 == 133683 or tile_14 == 133686 
									or tile_14 == 133689 or tile_14 == 133692 or tile_14 == 133695 or tile_14 == 133696 or tile_14 == 133699 or tile_14 == 133702 or tile_14 == 133705 
									or tile_14 == 133708 or tile_14 == 133711 or tile_14 == 133712 or tile_14 == 133715 or tile_14 == 133718 or tile_14 == 133721 or tile_14 == 133724 
									or tile_14 == 133727 or tile_14 == 133728 or tile_14 == 133731 or tile_14 == 133734 or tile_14 == 133737 or tile_14 == 133740 or tile_14 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_14', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_14b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_14b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_14', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_14)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_14
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_15_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_15 = managers.mission:script("default")._elements[tile_15_0]._values.on_executed[1].id
									local tile_15b = managers.mission:script("default")._elements[tile_15]._values.on_executed[1].id
									if tile_15 == 133631 or tile_15 == 133633	or tile_15 == 133634 or tile_15 == 133635 or tile_15 == 133636 or tile_15 == 133637 or tile_15 == 133650 
									or tile_15 == 133653 or tile_15 == 133656 or tile_15 == 133659 or tile_15 == 133662 or tile_15 == 133663 or tile_15 == 133666 or tile_15 == 133669 
									or tile_15 == 133672 or tile_15 == 133675 or tile_15 == 133678 or tile_15 == 133679 or tile_15 == 133680 or tile_15 == 133683 or tile_15 == 133686 
									or tile_15 == 133689 or tile_15 == 133692 or tile_15 == 133695 or tile_15 == 133696 or tile_15 == 133699 or tile_15 == 133702 or tile_15 == 133705 
									or tile_15 == 133708 or tile_15 == 133711 or tile_15 == 133712 or tile_15 == 133715 or tile_15 == 133718 or tile_15 == 133721 or tile_15 == 133724 
									or tile_15 == 133727 or tile_15 == 133728 or tile_15 == 133731 or tile_15 == 133734 or tile_15 == 133737 or tile_15 == 133740 or tile_15 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_15', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_15b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_15b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_15', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_15)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_15
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_16_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_16 = managers.mission:script("default")._elements[tile_16_0]._values.on_executed[1].id
									local tile_16b = managers.mission:script("default")._elements[tile_16]._values.on_executed[1].id
									if tile_16 == 133631 or tile_16 == 133633	or tile_16 == 133634 or tile_16 == 133635 or tile_16 == 133636 or tile_16 == 133637 or tile_16 == 133650 
									or tile_16 == 133653 or tile_16 == 133656 or tile_16 == 133659 or tile_16 == 133662 or tile_16 == 133663 or tile_16 == 133666 or tile_16 == 133669 
									or tile_16 == 133672 or tile_16 == 133675 or tile_16 == 133678 or tile_16 == 133679 or tile_16 == 133680 or tile_16 == 133683 or tile_16 == 133686 
									or tile_16 == 133689 or tile_16 == 133692 or tile_16 == 133695 or tile_16 == 133696 or tile_16 == 133699 or tile_16 == 133702 or tile_16 == 133705 
									or tile_16 == 133708 or tile_16 == 133711 or tile_16 == 133712 or tile_16 == 133715 or tile_16 == 133718 or tile_16 == 133721 or tile_16 == 133724 
									or tile_16 == 133727 or tile_16 == 133728 or tile_16 == 133731 or tile_16 == 133734 or tile_16 == 133737 or tile_16 == 133740 or tile_16 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_16', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_16b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_16b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_16', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_16)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_16
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_17_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_17 = managers.mission:script("default")._elements[tile_17_0]._values.on_executed[1].id
									local tile_17b = managers.mission:script("default")._elements[tile_17]._values.on_executed[1].id
									if tile_17 == 133631 or tile_17 == 133633	or tile_17 == 133634 or tile_17 == 133635 or tile_17 == 133636 or tile_17 == 133637 or tile_17 == 133650 
									or tile_17 == 133653 or tile_17 == 133656 or tile_17 == 133659 or tile_17 == 133662 or tile_17 == 133663 or tile_17 == 133666 or tile_17 == 133669 
									or tile_17 == 133672 or tile_17 == 133675 or tile_17 == 133678 or tile_17 == 133679 or tile_17 == 133680 or tile_17 == 133683 or tile_17 == 133686 
									or tile_17 == 133689 or tile_17 == 133692 or tile_17 == 133695 or tile_17 == 133696 or tile_17 == 133699 or tile_17 == 133702 or tile_17 == 133705 
									or tile_17 == 133708 or tile_17 == 133711 or tile_17 == 133712 or tile_17 == 133715 or tile_17 == 133718 or tile_17 == 133721 or tile_17 == 133724 
									or tile_17 == 133727 or tile_17 == 133728 or tile_17 == 133731 or tile_17 == 133734 or tile_17 == 133737 or tile_17 == 133740 or tile_17 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_17', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_17b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_17b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_17', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_17)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_17
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_18_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_18 = managers.mission:script("default")._elements[tile_18_0]._values.on_executed[1].id
									local tile_18b = managers.mission:script("default")._elements[tile_18]._values.on_executed[1].id
									if tile_18 == 133631 or tile_18 == 133633	or tile_18 == 133634 or tile_18 == 133635 or tile_18 == 133636 or tile_18 == 133637 or tile_18 == 133650 
									or tile_18 == 133653 or tile_18 == 133656 or tile_18 == 133659 or tile_18 == 133662 or tile_18 == 133663 or tile_18 == 133666 or tile_18 == 133669 
									or tile_18 == 133672 or tile_18 == 133675 or tile_18 == 133678 or tile_18 == 133679 or tile_18 == 133680 or tile_18 == 133683 or tile_18 == 133686 
									or tile_18 == 133689 or tile_18 == 133692 or tile_18 == 133695 or tile_18 == 133696 or tile_18 == 133699 or tile_18 == 133702 or tile_18 == 133705 
									or tile_18 == 133708 or tile_18 == 133711 or tile_18 == 133712 or tile_18 == 133715 or tile_18 == 133718 or tile_18 == 133721 or tile_18 == 133724 
									or tile_18 == 133727 or tile_18 == 133728 or tile_18 == 133731 or tile_18 == 133734 or tile_18 == 133737 or tile_18 == 133740 or tile_18 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_18', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_18b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_18b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_18', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_18)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_18
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_19_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_19 = managers.mission:script("default")._elements[tile_19_0]._values.on_executed[1].id
									local tile_19b = managers.mission:script("default")._elements[tile_19]._values.on_executed[1].id
									if tile_19 == 133631 or tile_19 == 133633	or tile_19 == 133634 or tile_19 == 133635 or tile_19 == 133636 or tile_19 == 133637 or tile_19 == 133650 
									or tile_19 == 133653 or tile_19 == 133656 or tile_19 == 133659 or tile_19 == 133662 or tile_19 == 133663 or tile_19 == 133666 or tile_19 == 133669 
									or tile_19 == 133672 or tile_19 == 133675 or tile_19 == 133678 or tile_19 == 133679 or tile_19 == 133680 or tile_19 == 133683 or tile_19 == 133686 
									or tile_19 == 133689 or tile_19 == 133692 or tile_19 == 133695 or tile_19 == 133696 or tile_19 == 133699 or tile_19 == 133702 or tile_19 == 133705 
									or tile_19 == 133708 or tile_19 == 133711 or tile_19 == 133712 or tile_19 == 133715 or tile_19 == 133718 or tile_19 == 133721 or tile_19 == 133724 
									or tile_19 == 133727 or tile_19 == 133728 or tile_19 == 133731 or tile_19 == 133734 or tile_19 == 133737 or tile_19 == 133740 or tile_19 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_19', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_19b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_19b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_19', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_19)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_19
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
								if _path_terminated == false then
									local tile_20_0 = managers.mission:script("default")._elements[_path_tile]._values.on_executed[1].id
									local tile_20 = managers.mission:script("default")._elements[tile_20_0]._values.on_executed[1].id
									local tile_20b = managers.mission:script("default")._elements[tile_20]._values.on_executed[1].id
									if tile_20 == 133631 or tile_20 == 133633	or tile_20 == 133634 or tile_20 == 133635 or tile_20 == 133636 or tile_20 == 133637 or tile_20 == 133650 
									or tile_20 == 133653 or tile_20 == 133656 or tile_20 == 133659 or tile_20 == 133662 or tile_20 == 133663 or tile_20 == 133666 or tile_20 == 133669 
									or tile_20 == 133672 or tile_20 == 133675 or tile_20 == 133678 or tile_20 == 133679 or tile_20 == 133680 or tile_20 == 133683 or tile_20 == 133686 
									or tile_20 == 133689 or tile_20 == 133692 or tile_20 == 133695 or tile_20 == 133696 or tile_20 == 133699 or tile_20 == 133702 or tile_20 == 133705 
									or tile_20 == 133708 or tile_20 == 133711 or tile_20 == 133712 or tile_20 == 133715 or tile_20 == 133718 or tile_20 == 133721 or tile_20 == 133724 
									or tile_20 == 133727 or tile_20 == 133728 or tile_20 == 133731 or tile_20 == 133734 or tile_20 == 133737 or tile_20 == 133740 or tile_20 == 133743 then
										managers.hud:add_waypoint( 'hudz_'..'tile_20', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_20b)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_20b
									else
										managers.hud:add_waypoint( 'hudz_'..'tile_20', { icon = 'wp_target', distance = false, position = tiles_all[tostring(tile_20)], no_sync = true, present_timer = 0, state = "present", radius = 1000, color = Color.green, blend_mode = "add" }  )
										_path_tile = tile_20
									end
									if _path_tile == 133600	or _path_tile == 133606	or _path_tile == 133612	or _path_tile == 133618	or _path_tile == 133624	or _path_tile == 133630 then
										-- LAST TILE!
										_path_terminated = true
									end
								end
							end
						end						

						if managers.job:current_level_id() == 'pines' then	
							-- WHITE XMAS PRESENTS
							if v:interaction().tweak_data == 'hold_open_xmas_present' and managers.job:current_level_id() == "pines" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_christmas_present', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
							end							
							-- WHITE XMAS PURE COCAINE
							if v:interaction().tweak_data == 'gen_pku_cocaine_pure' and managers.job:current_level_id() == "pines" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_vial', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
							end						
							-- WHITE XMAS ALMIRS TOAST
							if v:interaction().tweak_data == 'gen_pku_sandwich' and managers.job:current_level_id() == "pines" then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_loot', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.DodgerBlue, blend_mode = "add" }  )
							end
						end
						
						if managers.job:current_level_id() == 'hox_1' then
							-- Hox day 1
							if v:interaction().tweak_data == 'security_station_keyboard' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_keyboard', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
						end
						
						if managers.job:current_level_id() == 'hox_2' then
							-- Hox day 2
							if v:interaction().tweak_data == 'firstaid_box' 
							or v:interaction().tweak_data == 'invisible_interaction_open' 
							--or v:interaction().tweak_data == 'invisible_interaction_close' 
							then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_doctor_bag', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.orange, blend_mode = "add" }  )
							end
							
							if v:interaction().tweak_data == 'grenade_crate' or v:interaction().tweak_data == 'ammo_bag' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_ammo_bag', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.red, blend_mode = "add" }  )
							end
							
							if v:interaction().tweak_data == 'hold_download_keys' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_keyboard', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
							
							if v:interaction().tweak_data == 'invisible_interaction_gathering' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_evidence', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
							
							-- Files
							if v:interaction().tweak_data == 'search_files_false' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_files', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.red, blend_mode = "add" }  )
							end
							-- Correct file
							if v:interaction().tweak_data == 'invisible_interaction_searching' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_files', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
							
							if v:interaction().tweak_data == 'grab_server' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_stash_server', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
						end
						
						if managers.job:current_level_id() == 'framing_frame_1' or managers.job:current_level_id() == 'gallery' then
							-- FRAMING FRAME DAY 1 PAINTINGS
							if v:interaction().tweak_data == 'hold_take_painting' and managers.job:current_level_id() ~= "kosugi" then
								managers.hud:add_waypoint( 'hudz_b'..k, { icon = 'pd2_loot', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
							end
						end
						
						if managers.job:current_level_id() == 'mia_1' then
							-- HOTLINE MIAMI DAY 1
							if v:interaction().tweak_data == 'hold_take_gas_can' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_thermite', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
							if v:interaction().tweak_data == 'hlm_roll_carpet' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_target', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
						end
						
						if managers.job:current_level_id() == 'mia_2' then
							-- HOTLINE MIAMI DAY 2
							if v:interaction().tweak_data == 'disarm_bomb' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_target', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
							if v:interaction().tweak_data == 'hold_hlm_open_circuitbreaker' then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_powersupply', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 800, color = Color.green, blend_mode = "add" }  )
							end
						end
						
						-- TRAIN HEIST INTEL
						if (managers.job:current_level_id() == 'arm_hcm' 
							or managers.job:current_level_id() == 'arm_cro' 
							or managers.job:current_level_id() == 'arm_fac' 
							or managers.job:current_level_id() == 'arm_par' 
							or managers.job:current_level_id() == 'arm_und') 
						and v:interaction().tweak_data == 'take_confidential_folder_event' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_patientfile', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						end
						
						-- FRAMING FRAME DAY 3 COMPUTER LOCATION
						if v:interaction().tweak_data == 'use_computer' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'laptop_objective', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						-- FRAMING FRAME DAY 3 PHONE LOCATION
						elseif v:interaction().tweak_data == 'pickup_phone' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_phone', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						-- FRAMING FRAME DAY 3 TABLET LOCATION
						elseif v:interaction().tweak_data == 'pickup_tablet' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_hack_ipad', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						-- FRAMING FRAME DAY 3 SERVERS LOCATION
						elseif (v:interaction().tweak_data == 'hold_take_server' or v:interaction().tweak_data == 'stash_server_pickup') and managers.job:current_level_id() == "framing_frame_3" then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_stash_server', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						end
						
						-- RATS DAY 1
						if v:interaction().tweak_data == 'caustic_soda' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_methlab', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						elseif v:interaction().tweak_data == 'hydrogen_chloride' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_methlab', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						elseif v:interaction().tweak_data == 'muriatic_acid' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_methlab', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.yellow, blend_mode = "add" }  )
						end
						
						if managers.job:current_level_id() == 'alex_2' then
							if isHost() then
								local values = 
								{
									["103805"] = "Intel Revealer: Safe_01",
									["103806"] = "Intel Revealer: Safe_02",
									["103807"] = "Intel Revealer: Safe_03",		
									["103808"] = "Intel Revealer: Safe_04",
									["103809"] = "Intel Revealer: Safe_05",
									["103810"] = "Intel Revealer: Safe_06",
									["103811"] = "Intel Revealer: Safe_07",	
									["103812"] = "Intel Revealer: Safe_08",
									["103813"] = "Intel Revealer: Safe_09",
									["103814"] = "Intel Revealer: Safe_10",
									["103815"] = "Intel Revealer: Safe_11",
									["103816"] = "Intel Revealer: Safe_12",
									["103817"] = "Intel Revealer: Safe_13",
									["103818"] = "Intel Revealer: Safe_14",
									["103819"] = "Intel Revealer: Safe_15",
									["103820"] = "Intel Revealer: Safe_16"
								}
								
								local bo_safes = {
									["103805"] = Vector3(791, 1426, 50),
									["103806"] = Vector3(326, 1673, 50),
									["103807"] = Vector3(365, 2022, 103.2),	
									["103808"] = Vector3(560, 2175, 127.603),
									["103809"] = Vector3(2220, 1273, 82.103),
									["103810"] = Vector3(2079, 1013, 117.503),
									["103811"] = Vector3(2502, 1015, 50),
									["103812"] = Vector3(2332, 1100, 50),
									["103813"] = Vector3(3162, 2742, 82.1028),
									["103814"] = Vector3(2704, 2342, 114.325),
									["103815"] = Vector3(3400,2662,117.285),
									["103816"] = Vector3(2440, 2747, 50),
									["103817"] = Vector3(2474, 3414, 250),
									["103818"] = Vector3(3181, 3696, 250),
									["103819"] = Vector3(2625, 4003, 250),
									["103820"] = Vector3(2755, 3901, 250)
								}
								local bo_intel = tostring(managers.mission:script("default")._elements[103759]._values.on_executed[1].id)
								
								if _intel_used == false then 
									managers.hud:add_waypoint( 'hudz_'..bo_intel, { icon = 'interaction_patientfile', distance = true, position = bo_safes[bo_intel], no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
								end
							elseif isClient() then
								--managers.chat:_receive_message(1, "*WARNING*", "Intel Revealer is unavailable for you. Host ONLY.",  Color.red)
								-- 2 safes
								if (v:interaction().tweak_data == 'drill' or v:interaction().tweak_data == 'take_confidential_folder') then
									managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_patientfile', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.orange, blend_mode = "add" }  )
						end	end	end

						-- ELECTION DAY 1, COMPUTER LOCATION
						if v:interaction().tweak_data == 'uload_database' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_computer', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						end
						
						-- BIG BANK
						if managers.job:current_level_id() == 'big' and v:interaction().tweak_data == 'big_computer_server' then
							if _bbserv_used == false then
								managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_computer', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						end	end
						-- BIG BANK KEYBOARDS LOCATION
						if v:interaction().tweak_data == 'big_computer_hackable' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_keyboard', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						end
						
						-- FIRESTARTER DAY 2 SECURITY BOXES LOCATION
						if v:interaction().tweak_data == 'open_slash_close_sec_box' and managers.groupai:state():whisper_mode() and managers.job:current_level_id() == 'firestarter_2' then
							if isHost() then
								bo_boxes = {
									["105819"] = Vector3(-2710, -2830, 552), -- Box 001
									["105794"] = Vector3(-1840, -3195, 552), -- Box 002
									["105810"] = Vector3(-1540, -2195, 552), -- Box 003
									["105824"] = Vector3(-1005, -3365, 552), -- Box 004
									["105837"] = Vector3(-635, -1705, 552),	-- Box 005
									["105851"] = Vector3(-1095, -210, 152),	-- Box 006
									["106183"] = Vector3(-1230, 1510, 152),	-- Box 007
									["106529"] = Vector3(-1415, -795, 152),	-- Box 008
									["106543"] = Vector3(-1160, 395, 152), -- Box 009
									["106556"] = Vector3(-5, 735, 152),	-- Box 010
									["106581"] = Vector3(1360, 5, 552),	-- Box 011
									["106594"] = Vector3(795, -898, 552), -- Box 012
									["106607"] = Vector3(795, -3240, 552), -- Box 013
									["106620"] = Vector3(1060, -2195, 552), -- Box 014
									["106633"] = Vector3(204, 540, 578), -- Box 015
									["106646"] = Vector3(-1085, -1205, 552), -- Box 016
									["106659"] = Vector3(-2135, 395, 552), -- Box 017
									["106672"] = Vector3(-2405, -840, 552), -- Box 018
									["106685"] = Vector3(-2005, -1640, 552), -- Box 019
									["106698"] = Vector3(-2715, -1595, 552), -- Box 020
									["106711"] = Vector3(-320, -650, 1300),	-- Box 021
									["106724"] = Vector3(-400, -650, 1300),	-- Box 022
									["106737"] = Vector3(-300, -650, 1300),	-- Box 023		UNAVAILABLE
									["106750"] = Vector3(-200, -650, 1300),	-- Box 024
									["106763"] = Vector3(-100, -650, 1300),	-- Box 025
									["106776"] = Vector3(-635, -1205, 152),	-- Box 026
									["106789"] = Vector3(-1040, -95, 552),	-- Box 027
									["106802"] = Vector3(615, 395, 152),	-- Box 028
									["106815"] = Vector3(1890, -1805, 152),	-- Box 029
									["106828"] = Vector3(215, -1805, 152)	-- Box 030
								}
								
								SecBox1 = tostring(managers.mission:script("default")._elements[106836]._values.on_executed[1].id)
								SecBox2 = tostring(managers.mission:script("default")._elements[106836]._values.on_executed[2].id)

								if _box1_used == false then
									managers.hud:add_waypoint( 'hudz_'..SecBox1, { icon = 'interaction_wirecutter', distance = true, position = bo_boxes[SecBox1], no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
								end
								if _box2_used == false then
									managers.hud:add_waypoint( 'hudz_'..SecBox2, { icon = 'interaction_wirecutter', distance = true, position = bo_boxes[SecBox2], no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.blue, blend_mode = "add" }  )
								end
							elseif isClient() then
								nb = nb + 1
								if clientBox[nb] ~= 0 then
									clientBox[nb] = v:position()
									-- managers.chat:_receive_message(1, "Box_Client"..nb, tostring(clientBox[nb]),  Color.green)
									managers.hud:add_waypoint( 'hudb_'..k, { icon = 'interaction_wirecutter', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.yellow, blend_mode = "add" }  )
						end	end	end
						if nb == 5 then nb = 0 end
								
						-- BIG OIL DAY 1 INTEL
						if v:interaction().tweak_data == 'hold_take_blueprints' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_loot', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						elseif v:interaction().tweak_data == 'take_confidential_folder' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_loot', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						elseif v:interaction().tweak_data == 'pickup_asset' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_chavez_key', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.yellow, blend_mode = "add" }  )
						end
						-- BIG OIL DAY 1 SAFE
						if managers.job:current_level_id() == "welcome_to_the_jungle_1" and v:interaction().tweak_data == 'drill' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_drill', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						end
						
						if managers.job:current_level_id() == 'welcome_to_the_jungle_2' and v:interaction().tweak_data == 'gen_pku_fusion_reactor' then
							if isHost() then
								local values = 
								{
									["103717"] = "Fusion Engine Revealer: Engine_12",
									["103716"] = "Fusion Engine Revealer: Engine_11",
									["103715"] = "Fusion Engine Revealer: Engine_10",
									["103714"] = "Fusion Engine Revealer: Engine_09",
									["103711"] = "Fusion Engine Revealer: Engine_08",
									["103709"] = "Fusion Engine Revealer: Engine_07",
									["103708"] = "Fusion Engine Revealer: Engine_06",
									["103707"] = "Fusion Engine Revealer: Engine_05",
									["103706"] = "Fusion Engine Revealer: Engine_04",
									["103705"] = "Fusion Engine Revealer: Engine_03",
									["103704"] = "Fusion Engine Revealer: Engine_02",
									["103703"] = "Fusion Engine Revealer: Engine_01"
								}
								local engine_id = 
								{
									['103703'] = 'f0e7a7f29fc87c44', --Engine 01
									['103704'] = 'db218f98a571c0b1', --Engine 02
									['103705'] = 'c717770fadc88e04', --Engine 03
									['103706'] = '5fb0a3191c4b8202', --Engine 04
									['103707'] = '0b2ecebcf49765b9', --Engine 05
									['103708'] = 'b531a6b7026ad84f', --Engine 06
									['103709'] = 'e191b6d86e655e23', --Engine 07
									['103711'] = '5aabe6e626f00bd4', --Engine 08
									['103714'] = '5afbe85d94046cbe', --Engine 09
									['103715'] = '9f316997306803b9', --Engine 10
									['103716'] = 'b2560b63edcda138', --Engine 11
									['103717'] = 'ee644ab092313077'  --Engine 12
								}
								local srooms = 
								{
									["101865"] = "Server Room Revealer: 1st floor, Back of the property",
									["101866"] = "Server Room Revealer: 1st floor, Front of the property",
									["101915"] = "Server Room Revealer: Ground floor"
								}
								local keyboard_id = 
								{
									["101865"] = "8efe34cd3f706348",
									["101866"] = "8efe34cd3f706348",
									["101915"] = "8efe34cd3f706348"
								}
								local bo_servers = 
								{
									["101865"] = Vector3(-662, -2142, 475),	-- Room 1
									["101866"] = Vector3(-2129, 391, 475), -- Room 2
									["101915"] = Vector3(-384, -96, 75) -- Room 3
								}
								local bo_keyboard = tostring(managers.mission:script("default")._elements[101916]._values.on_executed[1].id)			
								local correct_id = tostring(managers.mission:script('default')._elements[103718]._values.on_executed[1].id)
								
								if lp == false then
									-- CHAT
									if _keyboard_used == false then
										managers.chat:_receive_message(1, "Server Room", srooms[tostring(managers.mission:script("default")._elements[101916]._values.on_executed[1].id)],  tweak_data.system_chat_color)
									end
									if _engine_used == false then
										managers.chat:_receive_message(1, "Big Oil", values[tostring(managers.mission:script("default")._elements[103718]._values.on_executed[1].id)],  tweak_data.system_chat_color)
									end
									lp = true
								end
								
								-- WAYPOINT SERVER
								if _keyboard_used == false then
									managers.hud:add_waypoint( 'hudz_'..bo_keyboard, { icon = 'interaction_keyboard', distance = true, position = bo_servers[bo_keyboard], no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
								end
									
								-- WAYPOINT	ENGINE
								if v:name():key() == engine_id[correct_id] then
									managers.hud:add_waypoint( 'hudz_'..correct_id, { icon = 'pd2_loot', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = 'present', radius = 320, color = Color.green, blend_mode = 'add' }  )
								end						
									elseif isClient() then	
								end	end
						
						-- SHADOW RAID SERVER
						if (v:interaction().tweak_data == 'hold_take_server' or v:interaction().tweak_data == 'stash_server_pickup') and managers.job:current_level_id() == "kosugi" then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_stash_server', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
						-- SHADOW RAID PAINTINGS
						elseif v:interaction().tweak_data == 'hold_take_painting' and managers.job:current_level_id() == "kosugi" then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_loot', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
						-- SHADOW RAID STATUE INSIDE CRATE
						elseif v:interaction().tweak_data == 'gen_pku_artifact_statue' or v:interaction().tweak_data == 'samurai_armor' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_scrubs', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
						-- SHADOW RAID SEWER MANHOLE
						elseif v:interaction().tweak_data == 'sewer_manhole' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_open_door', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						-- SHADOW RAID SEWER THERMITE
						elseif v:interaction().tweak_data == 'apply_thermite_paste' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_thermite', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						end
						
						-- TRAIN HEIST TURRET
						if v:interaction().tweak_data == 'disassemble_turret' and managers.job:current_level_id() == "arm_for" then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'equipment_sentry', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
						end
						
						if managers.job:current_level_id() == "arm_for" then
							if isHost() then
								local vault1 = tostring(managers.mission:script("default")._elements[104736]._values.on_executed[1].id)
								local vault2 = tostring(managers.mission:script("default")._elements[104737]._values.on_executed[1].id)
								local vault3 = tostring(managers.mission:script("default")._elements[104738]._values.on_executed[1].id)
								
								if _drill1_used == false then
									if vault1 == '104731' then
										managers.hud:add_waypoint( 'hudz_'..vault1, { icon = 'wp_target', distance = true, position = Vector3(-2710, -1152, 666), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
									elseif vault1 == '104729' then
										managers.hud:add_waypoint( 'hudz_'..vault1, { icon = 'wp_target', distance = true, position = Vector3(-1707, -1157, 667), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
								end	end
								
								if _drill2_used == false then
									if vault2 == '104732' then
										managers.hud:add_waypoint( 'hudz_'..vault2, { icon = 'wp_target', distance = true, position = Vector3(-192, -1152, 668), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.orange, blend_mode = "add" }  )
									elseif vault2 == '104733' then
										managers.hud:add_waypoint( 'hudz_'..vault2, { icon = 'wp_target', distance = true, position = Vector3(794, -1161, 668), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.orange, blend_mode = "add" }  )
								end	end
								
								if _drill3_used == false then
									if vault3 == '104734' then
										managers.hud:add_waypoint( 'hudz_'..vault3, { icon = 'wp_target', distance = true, position = Vector3(2291, -1155, 667), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
									elseif vault3 == '104735' then
										managers.hud:add_waypoint( 'hudz_'..vault3, { icon = 'wp_target', distance = true, position = Vector3(3308, -1151, 667), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
						end	end	end	end
								
						-- ELECTION DAY 3, KEYBOARD
						if managers.job:current_level_id() == 'election_day_3_skip1' and v:interaction().tweak_data == 'security_station_keyboard' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'interaction_keyboard', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.white, blend_mode = "add" }  )
						end
						
						-- UKRAINIAN JOB POWER
						if v:interaction().tweak_data == 'circuit_breaker' then
							managers.hud:add_waypoint( 'hudz_'..k, { icon = 'wp_powersupply', distance = true, position = v:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.red, blend_mode = "add" }  )
						end
						
						-- UKRAINIAN JOB TIARA LOCATION
						if managers.job:current_level_id() == "ukrainian_job" and _tiara_used == false then
							if isHost() or isClient() then
								local unit_list = World:find_units_quick( "all" ) 
								for _,unit in ipairs( unit_list ) do 
									if unit:base() and tostring(unit:name()) == "Idstring(@ID077636ce1f33c8d0@)" --[[TIARA]] then
										managers.hud:add_waypoint( 'hudz_'.._, { icon = 'pd2_loot', distance = true, position = unit:position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color("FFC0CB"), blend_mode = "add" }  )
						end	end	end	end
								
						-- FRAMING FRAME DAY 3 SERVER
						if managers.job:current_level_id() == 'framing_frame_3' then
							if isHost() then
								local servers = 
								{
									["105507"] = "Server Room 1",
									["105508"] = "Server Room 2",
									["100650"] = "Server Room 3"
								}
								local keyboard = 
								{
									["105507"] = "58cb6c4c6221c415",
									["105508"] = "58cb6c4c6221c415",
									["100650"] = "58cb6c4c6221c415"
								}
								local server_vectors = 
								{
									["105507"] = Vector3(-3937.26, 5644.73, 3474.5), -- Office
									["105508"] = Vector3(-3169.57, 4563.03, 3074.5), -- Hallway
									["100650"] = Vector3(-4920, 3737, 3074.5)    -- Living Room
								}
								
								local svectors = tostring(managers.mission:script("default")._elements[105506]._values.on_executed[1].id)
								
								-- WAYPOINT SERVER
								if _FF3_used == false then
									managers.hud:add_waypoint( 'hudz_'..svectors, { icon = 'interaction_keyboard', distance = true, position = server_vectors[svectors], no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
								end                    
							elseif isClient() and v:interaction().tweak_data == 'key' then
								--- already in state 2
								--managers.hud:add_waypoint( 'hudz_'..k, { icon = 'pd2_computer', distance = true, position = v:interaction():interact_position(), no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.orange, blend_mode = "add" }  )
						end	end
						
						-- ELECTION DAY 1 TRUCK
						if managers.job:current_level_id() == 'election_day_1' then
							if isHost() then
								local trucks = 
								{
									["100636"] = "1",
									["100633"] = "2",
									["100637"] = "3",
									["100634"] = "4",
									["100639"] = "5",
									["100635"] = "6"
								}
								local truckid = 
								{
									["100633"] = "3b0947a2434bdc93",
									["100634"] = "3b0947a2434bdc93",
									["100635"] = "3b0947a2434bdc93",
									["100636"] = "3b0947a2434bdc93",
									["100637"] = "3b0947a2434bdc93",
									["100639"] = "3b0947a2434bdc93"
								}
								local truck_vectors = 
								{
									["100636"] = Vector3(150, -3900, 0), -- 1st
									["100633"] = Vector3(878.392, -3360.24, 0), --2nd
									["100637"] = Vector3(149.999, -2775, 0), --3rd
									["100634"] = Vector3(828.07, -2222.45, 0), --4th
									["100639"] = Vector3(149.998, -1625, 0), --5th
									["100635"] = Vector3(848.961, -1084.9, 0) --6th
								}
								local truckv = tostring(managers.mission:script("default")._elements[100631]._values.on_executed[1].id)
																			
								-- WAYPOINT SERVER
								if _gps_used == false then
									managers.hud:add_waypoint( 'hudz_'..truckv, { icon = 'wp_target', distance = true, position = truck_vectors[truckv], no_sync = true, present_timer = 0, state = "present", radius = 320, color = Color.green, blend_mode = "add" }  )
								end                    
							else
				end	end	end	end
						
				local i = 0
				for id,_ in pairs( clone( managers.hud._hud.waypoints ) ) do
					id = tostring(id)
					if id:sub(1,5)=='hudz_' or id:sub(1,5)=='hudb_' then
						i = i + 1
				end	end     
				
				if i == 0 then
					_toggleWaypointAIO2 = _toggleWaypointAIO2 + 1
					if _toggleWaypointAIO2 > 6 then
						_toggleWaypointAIO2 = 0
						showHint('LOCATOR DISABLED', 2)
						-- managers.hud:present_mid_text( { text = "LOCATOR DISABLED", title = "WAYPOINT", time = 1 } )
						Overlay:gui():destroy_workspace( _HDmsg.ws)
						_HDmsg = nil
					end
					RefreshItemWaypoints()
					return
				end
				RefreshMsg()
end	end	end end
		
-- initialize waypoints
RefreshItemWaypoints()

--when a package is removed from the game, also refresh waypoints
managers.interaction._remove_object = managers.interaction._remove_object or managers.interaction.remove_object
function ObjectInteractionManager:remove_object( obj )
	local interacted = obj:interaction().tweak_data
	local result = self:_remove_object(obj)
	local position = obj:position()
	local position2 = obj:interaction():interact_position()

	-- STATE 1 : PACKAGE
	if ((_toggleWaypointAIO2 == 1) and interacted == 'gage_assignment')
	
	-- //// TEST \\\\ STATE 2 : CIV/COP KEYCARD  
	or ((_toggleWaypointAIO2 == 2) and (interacted == 'corpse_dispose' or interacted == 'corpse_alarm_pager'))
	
	-- STATE 2 : KEYCARD / SECURITY DOOR
	or ((_toggleWaypointAIO2 == 2) and interacted == 'pickup_keycard' )
	or ((_toggleWaypointAIO2 == 2) and interacted == 'invisible_interaction_open' )
	or ((_toggleWaypointAIO2 == 2) and managers.job:current_level_id() == 'big' and (interacted == 'invisible_interaction_open' or interacted == 'take_keys' ))
	or ((_toggleWaypointAIO2 == 2) and (managers.job:current_level_id() == 'family' and interacted == 'numpad_keycard'))
	or ((_toggleWaypointAIO2 == 2) and interacted == 'key' )
	or ((_toggleWaypointAIO2 == 2) and managers.job:current_level_id() == 'roberts' and (interacted == 'open_slash_close_act' or interacted == 'grenade_briefcase'))
	or ((_toggleWaypointAIO2 == 2) and (managers.job:current_level_id() == 'mus' and (interacted == 'invisible_interaction_open' or interacted == 'hack_suburbia' or interacted == 'access_camera')))
	
	-- STATE 3 : MONEY
	or ((_toggleWaypointAIO2 == 3) and (interacted == 'weapon_case' or interacted == 'take_weapons' or interacted == 'gen_pku_cocaine'
	or interacted == 'gen_pku_jewelry' or interacted == 'money_wrap' or interacted == 'diamond_pickup' or interacted == 'money_small' 
	or interacted == 'money_wrap_single_bundle' or interacted == 'cash_register' or interacted == 'gold_pile' or interacted == 'gen_pku_artifact' 
	or interacted == 'requires_ecm_jammer_atm' or interacted == 'gen_pku_artifact_painting' or interacted == 'mus_pku_artifact'))
	
	-- STATE 4 : PLANK
	or ((_toggleWaypointAIO2 == 4) and (interacted == 'stash_planks_pickup' or interacted == 'pickup_boards'))
	
	-- STATE 5 : CROWBAR / CRATE OPENABLE WITH CROWBAR
	or ((_toggleWaypointAIO2 == 5) and (interacted == 'crate_loot' or interacted == 'crate_loot_crowbar' or interacted == 'crate_loot_close' or interacted == 'gen_pku_crowbar' or interacted == 'votingmachine2'))
	
	-- STATE 6 : MIX
	or ((_toggleWaypointAIO2 == 6) and (interacted == 'hold_take_server' or interacted == 'stash_server_pickup' or interacted == 'hold_take_painting' 
		or interacted == 'big_computer_hackable' or interacted == 'uload_database' or interacted == 'gen_pku_artifact_statue' 
		or interacted == 'use_computer' or interacted == 'pickup_phone'	or interacted == 'pickup_tablet' 
		or interacted == 'big_computer_server' or interacted == 'sewer_manhole' or interacted == 'pickup_asset' or interacted == 'disassemble_turret'
		or interacted == 'circuit_breaker' or interacted == 'apply_thermite_paste' or interacted == 'take_confidential_folder_event'
		or interacted == 'hold_take_gas_can' or interacted == 'hlm_roll_carpet'	or interacted == 'disarm_bomb' or interacted == 'hold_hlm_open_circuitbreaker'
	))
	or ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'alex_1' and (interacted == 'caustic_soda' or interacted == 'hydrogen_chloride' or interacted == 'muriatic_acid')))
	or ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'alex_2' and (interacted == 'take_confidential_folder' or interacted == 'drill')))
	or ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'welcome_to_the_jungle_1' and (interacted == 'drill')))
	then
		RefreshItemWaypoints()
	end
	
	-- STATE 6 HOX 1
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'hox_1' and (interacted == 'security_station_keyboard'))) then
		RefreshItemWaypoints()
	end
	-- STATE 6 HOX 2
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'hox_2' and 
		(interacted == 'firstaid_box' or interacted == 'invisible_interaction_open' or interacted == 'grenade_crate' or interacted == 'ammo_bag' or interacted == 'hold_download_keys' 
		or interacted == 'invisible_interaction_gathering' or interacted == 'search_files_false' or interacted == 'invisible_interaction_searching' or interacted == 'grab_server' ))) 
	then
		RefreshItemWaypoints()
	end

	-- White Xmas
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'pines' and (interacted == 'hold_open_xmas_present' or interacted == 'gen_pku_cocaine_pure' or interacted == 'gen_pku_sandwich'))) then
		RefreshItemWaypoints()
	end	
	
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'mus' and interacted == 'hack_electric_box')) then
		RefreshItemWaypoints()
		_path_created = os.clock()
		managers.chat:_receive_message(1, "WARNING", "The path is currently being created. \nPlease wait few seconds before reactivating the script.", Color.orange)
		RefreshItemWaypoints()
	end
	
	-- STATE 6 TRAIN HEIST
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'arm_for' and interacted == 'lance')) then
	
		if position == Vector3(-1750, -1200, 685) or position == Vector3(-2650, -1100, 685) then
		_drill1_used = true -- GREEN
		
		elseif position == Vector3(-150, -1100, 685) or position == Vector3(750, -1200, 685) then
		_drill2_used = true -- ORANGE
		
		elseif position == Vector3(3250, -1200, 685) or position == Vector3(2350, -1100, 685) then
		_drill3_used = true -- RED
		
		end
		RefreshItemWaypoints()
	end
	
	-- STATE 6 TIARA LOCATION
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'ukrainian_job' and interacted == 'tiara_pickup')) then
		_tiara_used = true
		RefreshItemWaypoints()
	end
	
	-- STATE 6 FRAMING FRAME DAY 3 SERVER ROOM
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'framing_frame_3' and interacted == 'security_station_keyboard')) then
		_FF3_used = true
		RefreshItemWaypoints()
	end
	-- STATE 6 ELECTION DAY 1 TRUCK
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'election_day_1' and interacted == 'hold_place_gps_tracker')) then
		_gps_used = true
		RefreshItemWaypoints()
	end
	
	-- STATE 6 BIG OIL DAY 2 SERVER ROOM
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'welcome_to_the_jungle_2' and interacted == 'security_station_keyboard')) then
		_keyboard_used = true
		RefreshItemWaypoints()
	end
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'welcome_to_the_jungle_2' and interacted == 'gen_pku_fusion_reactor')) then
		_engine_used = true
		RefreshItemWaypoints()
	end
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'alex_2' and interacted == 'take_confidential_folder')) then
		_intel_used = true
		RefreshItemWaypoints()
	end
	-- STATE 6 FIRESTARTER DAY 2
	if ((_toggleWaypointAIO2 == 6) and (managers.job:current_level_id() == 'firestarter_2')) then
		if isHost() then
			if interacted == 'hospital_security_cable' then
				tabclk[1] = os.clock()
			elseif interacted == 'open_slash_close_sec_box' then
				tabclk[2] = os.clock()
			end

			if (tabclk[1] ~= nil and tabclk[2] ~= nil) or (tabclk[1] == nil and tabclk[2] ~= nil) then
				if tabclk[1] == nil then tabclk[1] = 0 end -- to prevent a nil value if you want to cut the first cable
				local test = tabclk[2] - tabclk[1]			
				if test < 0.5 and test > 0 or test < 0 and test > -0.5 then
					-- CLOSING THE BOX
				else
					-- CUTTING THE CABLE OR OPENING THE BOX
					if interacted == 'hospital_security_cable' and position == bo_boxes[SecBox1] then 
						_box1_used = true
						RefreshItemWaypoints()
					elseif interacted == 'hospital_security_cable' and position == bo_boxes[SecBox2] then
						_box2_used = true
						RefreshItemWaypoints()
					end	
				end	
			end
				
			if not managers.groupai:state():whisper_mode() then
				_box1_used = true
				_box2_used = true
				RefreshItemWaypoints()
			end
		elseif isClient() then
			if not managers.groupai:state():whisper_mode() then
				_box1_used = true
				_box2_used = true
				RefreshItemWaypoints()
			end
			if interacted == 'hospital_security_cable' then
				local vecX = position2.x
				local vecY = position2.y
				
				for k, v in pairs(clientBox) do
					if clientBox[k] ~= 0 then
						if 
							(vecX < clientBox[k].x + 50 and vecX > clientBox[k].x - 50)
						and
							(vecY < clientBox[k].y + 50 and vecY > clientBox[k].y - 50)
						then
							clientBox[k] = 0
							clientSucceed = clientSucceed + 1
							RefreshItemWaypoints()
						end
					end
					if clientSucceed == 2 then
						clientBox[1] = 0
						clientBox[2] = 0
						clientBox[3] = 0
						clientBox[4] = 0
						clientBox[5] = 0
						RefreshItemWaypoints()
					end	
				end	
			end	
		end	
	end
	
	if game_state_machine:current_state_name() == "victoryscreen" or string.find(game_state_machine:current_state_name(), "victoryscreen") 
	or game_state_machine:current_state_name() == "gameoverscreen" or string.find(game_state_machine:current_state_name(), "gameoverscreen") then
		_toggleWaypointAIO2 = 0
		if not _HDmsg then			
		else
			_HDmsg.lbl:set_text("")
			_HDmsg.lbl2:set_text("")
			_HDmsg.lbl3:set_text("")
			_HDmsg.lbl4:set_text("")
		end
	end
	return result
end

-- IF MAP IS GO BANK AND KEYCARD OR BRIEFCASE ARE SPAWNED, ALSO REFRESH WAYPOINTS
managers.interaction._add_object = managers.interaction._add_object or managers.interaction.add_object
function ObjectInteractionManager:add_object( obj )
	local spawned = obj:interaction().tweak_data
	local result = self:_add_object(obj)
	if managers.job:current_level_id() == 'roberts' and (spawned == 'pickup_keycard' or spawned == 'grenade_briefcase') then
		RefreshItemWaypoints()
	elseif (spawned == 'pickup_keycard' or spawned == 'grenade_briefcase') then
		RefreshItemWaypoints()
	end
	return result
end	