---------------
---- GAME -----
---------------
if not MoneyMenu then
	-- ENABLE INTERACTION WITH ANYTHING
	local function enableinteract1()
		Toggle.interact_with_all = not Toggle.interact_with_all
			
		-- DISABLE
		if not Toggle.interact_with_all then
			backuper:restore('BaseInteractionExt._has_required_upgrade')
			backuper:restore('BaseInteractionExt._has_required_deployable')
			backuper:restore('BaseInteractionExt.can_interact')
			backuper:restore('PlayerManager.remove_equipment')
			return
		end
		
		-- ENABLE
		backuper:backup('BaseInteractionExt._has_required_upgrade')
		function BaseInteractionExt:_has_required_upgrade() return true end
		
		backuper:backup('BaseInteractionExt._has_required_deployable')
		function BaseInteractionExt:_has_required_deployable() return true end
		
		backuper:backup('BaseInteractionExt.can_interact')
		function BaseInteractionExt:can_interact() return true end
		
		backuper:backup('PlayerManager.remove_equipment')
		function PlayerManager:remove_equipment() end
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- OPEN WEAPON CRATES/PRESENTS 
	function pickweap()
		local openbox = {}
		local id
		for _,v in pairs(managers.interaction._interactive_objects) do
			if v.interaction then
				id = string.sub(v:interaction()._unit:name():t(), 1, 10)
				if id =="@IDd40d72e" or id == "@IDa096513" or id == "@IDc0c4c07" then
					table.insert(openbox, v:interaction())
				end 
			end 
		end
		for _,v in pairs(openbox) do v:interact(managers.player:player_unit()) end 
	end
	
	-- BAG LOOT/JEWELRY
	function takeloot()
		pickweap()
		local instanttakeloot = {}
		local id
		for _,v in pairs(managers.interaction._interactive_objects) do
			if v.interaction then
				id = string.sub(v:interaction()._unit:name():t(), 1, 10)
				if id == "@IDeee53eb" or id =="@ID3107c02" or id =="@IDe6cb9c8"
				or id =="@IDda87b02" or id =="@IDa781595" or id =="@IDac3b1b2"
				or id =="@IDbe729c1" or id =="@IDe3522eb" or id =="@ID1a1c9b0"
				or id =="@IDdcfbd93" or id =="@IDe258187" or id =="@IDd8b036e"
				or id =="@IDb5e81fa" or id =="@ID1a40f6a" or id =="@IDcea0d9d"
				or id =="@ID1150f5c" or id =="@ID2054702" or id =="@ID79e0375"
				or id =="@ID8a1494c" or id =="@ID4ba585b" or id =="@ID4350ae5"
				or id =="@IDdeeb533" or id =="@ID8183b8a" or id =="@IDd9a7dcc" 
				or id =="@IDec27da3" or id =="@IDd645656" or id =="@IDcdcb6b1" 
				or id =="@ID89ddf8d" or id =="@ID2155f10" or id =="@ID8b7bad2" 
				or id =="@ID630a6b4" or id =="@ID8e89663" or id =="@ID5668018" 
				or id =="@ID4f3caa0" or id =="@ID76ff3d6" or id =="@IDcf78cd1"
				or id =="@ID1254b90" or id =="@ID07ff59f" or id =="@ID9e9773f"
				or id =="@ID077dcb9" or id =="@ID6b74e63" or id =="@ID8699a54"
				or id =="@ID419f4af" or id =="@ID6471d01" or id =="@IDd887f2d"
				or id =="@ID07943eb" or id =="@ID9da19a1" or id =="@ID6bd3b60"
				or id =="@ID14da9df" or id =="@ID4792b0a" or id =="@IDceed170"
				or id =="@ID5ce5749" or id =="@IDd89f48b" or id =="@ID4e96258"
				or id =="@ID765d407" or id =="@ID9bc0b7b" or id =="@ID01dee30" 
				or id =="@ID952e93d" or id =="@IDaa9663f" or id =="@IDaff2700"
				or id =="@IDc82e428" or id =="@ID6452495" or id =="@ID39646fd"
				or id =="@ID9a4d5cb" or id =="@IDa0df997" then
					table.insert(instanttakeloot, v:interaction())
				end 
			end 
		end
		for _,v in pairs(instanttakeloot) do v:interact(managers.player:player_unit()) end
		ChatMessage('All Loot Bagged', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	function OpenAtm()
		enableinteract1()
		InteractType({'requires_ecm_jammer_atm', 'invisible_interaction_open'})
		enableinteract1()
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	function OpenAllLoot()
		enableinteract1()
		InteractType({'requires_ecm_jammer_atm', 'cash_register', 'pick_lock_hard'})
		enableinteract1()
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- SECURE SMALL LOOT
	function securesmloot()
		for i = 1,20 do
			managers.loot:secure_small_loot("gen_atm", 3)
		end	
		ChatMessage('Small Loot Secured', 'MVP')
	end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	MoneyMenu = CustomMenuClass:new()
	MoneyMenu:addMainMenu('main_menu', {title = 'Money Menu - Select Option'})
	MoneyMenu:addMainMenu('secure_menu', {title = 'Super Loot Giver 69000'})
	
	MoneyMenu:addInformationOption('main_menu', 'MONEY OPTIONS', {textColor = Color.DodgerBlue})
	if isHost() then
		MoneyMenu:addOption('main_menu', 'Bag All Loot', {callback = takeloot, help = 'Must Enable CarryStacker, If White Xmas Press Twice', closeMenu = true})
	else
		MoneyMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	MoneyMenu:addOption('main_menu', 'Grab All Small Loot', {callback = InteractType, callbackData = {"safe_loot_pickup", "diamond_pickup", "tiara_pickup", "money_wrap_single_bundle", "invisible_interaction_open"}, closeMenu = true})
	MoneyMenu:addOption('main_menu', 'Open All ATMs & Take Content', {callback = OpenAtm, help = 'Press Twice To Take ATM Contents'})
	MoneyMenu:addOption('main_menu', 'Open All ATMs, Safes, Money Drawers', {callback = OpenAllLoot})
	for i = 6,10 do	
		MoneyMenu:addGap('main_menu')
	end
	MoneyMenu:addInformationOption('main_menu', 'SECURE OPTIONS/MENU', {textColor = Color.DodgerBlue})
	MoneyMenu:addMenuOption('main_menu', 'Secure Loot Menu', 'secure_menu', {rectHighlightColor = Color.red})
	for i,carry in pairs(tweak_data.carry) do
		if (carry) then
			if (carry.name_id and carry.bag_value) then
				MoneyMenu:addOption('secure_menu', managers.localization:text(carry.name_id), {callback = SecureBag, callbackData = carry.bag_value})
			end
		end
	end	
	MoneyMenu:addOption('main_menu', 'Secure Small Loot', {callback = securesmloot, closeMenu = true, help = 'Silently Secure Extra Small Loot'})
end
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
if inGame() and isPlaying() then
	if MoneyMenu:isOpen() then
		MoneyMenu:close()
	else
		if ChangerMenu then
			if ChangerMenu:isOpen() then
				ChangerMenu:close()
			end	
		end
		if PlayerMenu then
			if PlayerMenu:isOpen() then
				PlayerMenu:close()
			end	
		end	
		if StealthMenu then
			if StealthMenu:isOpen() then
				StealthMenu:close()
			end	
		end	
		if MissionMenu then
			if MissionMenu:isOpen() then
				MissionMenu:close()
			end	
		end
		if InventoryMenu then
			if InventoryMenu:isOpen() then
				InventoryMenu:close()
			end	
		end		
		if NumpadMenu then
			if NumpadMenu:isOpen() then
				NumpadMenu:close()
			end	
		end
		if InteractTimerMenu then	
			if InteractTimerMenu:isOpen() then
				InteractTimerMenu:close()
			end	
		end
		MoneyMenu:open()
	end 
end