----------------------------
-- Loot Value Modifier v1 --
----- By: Sirgoodsmoke -----
----------------------------
-- EDIT CASH VALUES HERE, SEVERAL MUTLIPLIERS ARE FACTORED INTO VALUE
-- VERY HARD						
local AFStatueVeryHard = 1	-- ARTIFACT STATUE		
local AmmoVeryHard = 1		-- AMMO BAG		
local PersonVeryHard = 1	-- BODYBAG		
local CokeVeryHard = 1		-- COKE 		
local FBIVeryHard = 1		-- FBI SERVER 		
local GoldVeryHard = 1		-- GOLD		
local JewelVeryHard = 1		-- JEWELRY		
local MethVeryHard = 1		-- METH		
local MoneyVeryHard = 1		-- MONEY		
local PaintingVeryHard = 1	-- PAINTING		
local SamSuitVeryHard = 1	-- SAMURAI SUIT		
local TurretVeryHard = 1	-- TURRET		
local WeaponVeryHard = 1	-- WEAPON		

-- OVERKILL					
local AFStatueOverKill = 1	-- ARTIFACT STATUE
local AmmoOverKill = 1      -- AMMO BAG
local PersonOverKill = 1	-- BODYBAG
local CokeOverKill = 1		-- COKE 
local FBIOverKill = 1		-- FBI SERVER 
local GoldOverKill = 500		-- GOLD
local JewelOverKill = 1		-- JEWELRY
local MethOverKill = 1		-- METH
local MoneyOverKill = 1		-- MONEY
local PaintingOverKill = 1	-- PAINTING
local SamSuitOverKill = 1	-- SAMURAI SUIT
local TurretOverKill = 1	-- TURRET
local WeaponOverKill = 1    -- WEAPON

-- DEATHWISH	
local AFStatueDeathwish = 1	-- ARTIFACT STATUE
local AmmoDeathwish = 1		-- AMMO BAG
local PersonDeathwish = 1	-- BODYBAG
local CokeDeathwish = 1		-- COKE 
local FBIDeathwish = 1		-- FBI SERVER 
local GoldDeathwish = 500		-- GOLD
local JewelDeathwish = 1 	-- JEWELRY
local MethDeathwish = 1		-- METH
local MoneyDeathwish = 1 	-- MONEY
local PaintingDeathwish = 1	-- PAINTING
local SamSuitDeathwish = 1	-- SAMURAI SUIT
local TurretDeathwish = 1	-- TURRET
local WeaponDeathwish = 1	-- WEAPON
-----------------------------------------------------------------------------------------------------------------------------
function lootmod()
	if isHost() then	
		local get_bag_value_original = MoneyManager.get_bag_value
		function MoneyManager:get_bag_value(carry_id, multiplier)	
			local difficulty = Global.game_settings and Global.game_settings.difficulty or "normal"
			local difficulty_index = tweak_data:difficulty_to_index(difficulty)
			
			if difficulty_index == 4 then
				if carry_id == "person" then
					return PersonVeryHard
				elseif carry_id == "turret" then
					return TurretVeryHard
				elseif carry_id == "ammo" then
					return AmmoVeryHard
				elseif carry_id == "gold" then
					return GoldVeryHard
				elseif carry_id == "money" then
					return MoneyVeryHard
				elseif carry_id == "coke" then
					return CokeVeryHard
				elseif carry_id == "meth" then
					return MethVeryHard
				elseif carry_id == "painting" then
					return PaintingVeryHard
				elseif carry_id == "weapon" then
					return WeaponVeryHard
				elseif carry_id == "artifact_statue" then
					return AFStatueVeryHard
				elseif carry_id == "samurai_suit" then
					return SamSuitVeryHard
				elseif carry_id == "circuit" then
					return FBIVeryHard
				elseif carry_id == "diamonds" then
					return JewelVeryHard
				end	
			elseif difficulty_index == 5 then
				if carry_id == "person" then
					return PersonOverKill
				elseif carry_id == "turret" then
					return TurretOverKill
				elseif carry_id == "ammo" then
					return AmmoOverKill
				elseif carry_id == "gold" then
					return GoldOverKill
				elseif carry_id == "money" then
					return MoneyOverKill
				elseif carry_id == "coke" then
					return CokeOverKill
				elseif carry_id == "meth" then
					return MethOverKill
				elseif carry_id == "painting" then
					return PaintingOverKill
				elseif carry_id == "weapon" then
					return WeaponOverKill
				elseif carry_id == "artifact_statue" then
					return AFStatueOverKill
				elseif carry_id == "samurai_suit" then
					return SamSuitOverKill
				elseif carry_id == "circuit" then
					return FBIOverKill
				elseif carry_id == "diamonds" then
					return JewelOverKill
				end	
			elseif difficulty_index == 6 then
				if carry_id == "person" then
					return PersonDeathwish
				elseif carry_id == "turret" then
					return math.round(TurretDeathwish)
				elseif carry_id == "ammo" then
					return AmmoDeathwish
				elseif carry_id == "gold" then
					return math.round(GoldDeathwish)
				elseif carry_id == "money" then
					return MoneyDeathwish
				elseif carry_id == "coke" then
					return CokeDeathwish
				elseif carry_id == "meth" then
					return MethDeathwish
				elseif carry_id == "painting" then
					return PaintingDeathwish
				elseif carry_id == "weapon" then
					return WeaponDeathwish
				elseif carry_id == "artifact_statue" then
					return AFStatueDeathwish
				elseif carry_id == "samurai_suit" then
					return math.round(SamSuitDeathwish)
				elseif carry_id == "circuit" then
					return math.round(FBIDeathwish)
				elseif carry_id == "diamonds" then
					return math.round(JewelDeathwish)
				end
			end			
			return get_bag_value_original(self, carry_id, multiplier)
		end
		
		function MoneyManager:get_secured_bonus_bag_value(carry_id, multiplier)
			local carry_value = managers.money:get_bag_value(carry_id, multiplier)
			local bag_value = 0
			if managers.loot:is_bonus_bag(carry_id) then
				bag_value = carry_value
			else
				bag_value = carry_value
			end
			return math.round(bag_value)
		end
		
		function MoneyManager:get_secured_bonus_bags_money()
			local bonus_bags = managers.loot:get_secured_bonus_bags_value(managers.job:current_level_id())
			local bag_value = bonus_bags
			return math.round(bag_value)
		end
		ChatMessage('Enabled', 'LOOTMOD')
	end
end