if not MissionMenu then
	------------
	--- GAME ---
	------------
	-- ENABLE INTERACTION WITH ANYTHING
	local function enableinteract()
		Toggle.interact_with_all = not Toggle.interact_with_all
			
		-- DISABLE
		if not Toggle.interact_with_all then
			backuper:restore('BaseInteractionExt._has_required_upgrade')
			backuper:restore('BaseInteractionExt._has_required_deployable')
			backuper:restore('BaseInteractionExt.can_interact')
			backuper:restore('PlayerManager.remove_equipment')
			return
		end
		
		-- ENABLE
		backuper:backup('BaseInteractionExt._has_required_upgrade')
		function BaseInteractionExt:_has_required_upgrade() return true end
		
		backuper:backup('BaseInteractionExt._has_required_deployable')
		function BaseInteractionExt:_has_required_deployable() return true end
		
		backuper:backup('BaseInteractionExt.can_interact')
		function BaseInteractionExt:can_interact() return true end
		
		backuper:backup('PlayerManager.remove_equipment')
		function PlayerManager:remove_equipment() end
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- BOARD UP WINDOWS
	function instaboardst()
		enableinteract()
		InteractType({'need_boards', 'stash_planks'})
		enableinteract()
		ChatMessage('All Windows Boarded Up', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------				
	-- PLACE/RESTART DRILL ON DOORS/VAULT/SAFE
	function DrillAll()
		InteractType({'drill', 'drill_upgrade', 'drill_jammed', 'lance', 'lance_upgrade', 'lance_jammed', 'huge_lance', 'huge_lance_upgrade', 'huge_lance_jammed', 'apartment_drill', 'apartment_drill_jammed', 'suburbia_drill', 'suburbia_drill_jammed', 'goldheist_drill', 'goldheist_drill_jammed'})
		ChatMessage('Drill(s) Placed/Restarted', 'MVP')
	end	
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- BANKBUSTER v3
	function bankbuster()
		local depositboxes = {}
		for _,v in pairs(managers.interaction._interactive_objects) do
			if v.interaction then
				local id = string.sub(v:interaction()._unit:name():t(), 1, 10)
				if id == "@ID7999172" -- Harvest Bank
				or id == "@IDe4bc870" or id == "@ID51da6d6" or id == "@ID8d8c766" or id == "@ID50aac55" or id == "@ID5dcd177" --Armoured Transport
				or id == "@IDa95e021" -- The Big Bank
				or id == "@IDe93c9b2" then -- GO Bank
					table.insert(depositboxes, v:interaction())
				end	
			end 
		end 	
		for _,v in pairs(depositboxes) do
			v:interact(managers.player:player_unit())
		end
		ChatMessage('All Deposits Boxes Opened', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------				
	-- OPEN ALL DOORS
	function picklockst()
		local locksmith = {}
		local id
		for _,v in pairs(managers.interaction._interactive_objects) do
			if v.interaction then
				id = string.sub(v:interaction()._unit:name():t(), 1, 10)
				if id == "@IDe653b95" or id == "@ID18a7cac" or id == "@IDa25106d"
				or id == "@IDb025e83" or id == "@ID08a3353" or id == "@ID851f323"
				or id == "@ID8e70272" or id == "@ID1d283db" or id == "@ID5a95fe8"
				or id == "@ID622b34c" or id == "@ID1e56fe5" or id == "@IDa096513"
				or id == "@IDcfb8d38" or id == "@IDb68beff" or id == "@IDcfb8d38"
				or id == "@ID31ccfa0" or id == "@IDe653b95" or id == "@IDd40d72e" 
				or id == "@IDcffcea3" or id == "@ID559c3e4" or id == "@IDcfffc73"
				or id == "@IDbcd14bd" or id == "@ID5eb73ed" then
					table.insert(locksmith, v:interaction())
				end 
			end 
		end
		for _,v in pairs(locksmith) do v:interact(managers.player:player_unit()) end
		ChatMessage('All Windows And Doors Opened', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- INSTANT GRAB DIAMOND (THE DIAMOND ONLY)
	function GrabDiamond()
		InteractType({'mus_hold_open_display', 'mus_take_diamond'})
		ChatMessage('Diamond Acquired', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- OPEN ALL CRATES
	function opencrate()
		enableinteract()
		InteractType({'crate_loot', 'crate_loot_crowbar', 'crate_weapon_crowbar', 'crate_loot_close'})
		enableinteract()
		ChatMessage('All Crates Opened', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------				
	-- USE KEYCARD
	function usekeycardt()
		enableinteract()
		local usekey = {}
		local id
		for _,v in pairs(managers.interaction._interactive_objects) do
			if v.interaction then
				id = string.sub(v:interaction()._unit:name():t(), 1, 10)
				if id == "@ID15d846f" or id == "@ID2a72308" then
					table.insert(usekey, v:interaction())
				end 
			end 
		end
		for _,v in pairs(usekey) do v:interact(managers.player:player_unit()) end
		enableinteract()
		ChatMessage('Doors Opened With Keycard', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------				
	-- TIE ALL CIVs
	function instanttie()
		enableinteract()
		InteractType({"requires_cable_ties", 'intimidate'})
		enableinteract()
		ChatMessage('All Civs Tied Up', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- INSTANT OPEN & HACK VOTES MACHINES
	function instanthackmachines()
		enableinteract()
		InteractType({'votingmachine2', 'votingmachine2_jammed'})
		enableinteract()
		ChatMessage('All Voting Machines Hacked And Opened', 'MVP')
	end	
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- CUT ALL GLASS (THE DIAMOND ONLY)
	function cutglass()
		enableinteract()
		InteractType({'glass_cutter', 'glass_cutter_jammed', 'cut_glass'})
		enableinteract()
		ChatMessage('All Glass Cut', 'MVP')
	end	
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- INSTANT HACK PHONES, KEYPADS, COMPUTER, BOXES
	function InstantHackAll()
		enableinteract()
		InteractType({
			'use_computer', 'hospital_phone', 'iphone_answer', 'numpad_keycard', 'pickup_phone', 'timelock_numpad', 'big_computer_hackable', 'big_computer_not_hackable', 'big_computer_server', 'hold_use_computer', 'hack_numpad', 
			'timelock_hack', 'timelock_panel', 'uload_database', 'uload_database_jammed', 'hold_call_captain', 'move_ship_gps_coords', 'hold_hack_comp', 'hack_ipad', 'hack_ipad_jammed', 'hack_suburbia', 'hack_suburbia_jammed', 'hack_electric_box', 
			'hack_ship_control', 'security_station', 'security_station_keyboard', 'security_station_jammed', 'keyboard_no_time', 'keyboard_eday_1', 'keyboard_eday_2', 'keyboard_hox_1', 'use_server_device', 'enter_code', 'hold_download_keys', 
			'requires_ecm_jammer_double', 'rewire_electric_box', 'rewire_timelock', 'invisible_interaction_open'
		})
		enableinteract()
		ChatMessage('All Electrical/Circuit Boxes Hacked And Opened', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- INSTANT GRAB ALL COURIER PACKAGES
	function grabcourier()
		InteractType({'gage_assignment'})
		ChatMessage('All Gage Packages Grabbed', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- MISSION MANIPULATOR/CONTINUE MISSON
	function getpatht()
		local ontrack = {} 
		local id
		for _,v in pairs(managers.interaction._interactive_objects) do
			if v.interaction then
				id = string.sub(v:interaction()._unit:name():t(), 1, 10)
				if id == "@ID99aa0ad" or id == "@ID51001ab" or id == "@IDca8a8a2"
				or id == "@ID51001ab" or id == "@ID03777a0" or id == "@ID4a6b073"
				or id == "@ID7883aa4" or id == "@IDeee53eb" or id == "@ID1a1c9b0"
				or id == "@IDda87b02" or id == "@ID9140188" or id == "@ID15d846f"
				or id == "@ID4e2b16f" or id == "@IDf1461ef" or id == "@ID7dc5f75"
				or id == "@IDd8b036e" or id == "@ID9140188" or id == "@ID39a5689"
				or id == "@ID22c41a3" or id == "@IDdf59d98" or id == "@ID5a95fe8"
				or id == "@ID6a55816" or id == "@IDf105b35" or id == "@IDd8b036e"
				or id == "@ID64b82ec" or id == "@ID1f6a50d" or id == "@ID077636c"
				or id == "@ID6dbc2f1" or id == "@IDdd16274" or id == "@ID136f21b"
				or id == "@ID2be5897" or id == "@IDc54c876" or id == "@IDdb2e8d0"
				or id == "@ID2a72308" or id == "@IDd5e1a53" or id == "@ID853940b"
				or id == "@IDcfbdf01" or id == "@IDbb82cfc" or id == "@ID54e8d78"
				or id == "@IDd90bf4a" or id == "@ID0275b3e" or id == "@ID08a6323"
				or id == "@IDdd0578d" or id == "@ID4ba585b" or id == "@IDe258187"
				or id == "@ID5422d8b" or id == "@IDe6cb9c8" then 
					table.insert(ontrack, v:interaction())
				end 
			end 
		end
		for _,v in pairs(ontrack) do v:interact(managers.player:player_unit()) end
		ChatMessage('Mission Items Acquired', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- OPEN ALL DOORS WITH ECM
	function ecmopen()
		if isHost() then
			enableinteract()
			local ecjam = {}
			local id
			for _,v in pairs(managers.interaction._interactive_objects) do
				if v.interaction then
					id = string.sub(v:interaction()._unit:name():t(), 1, 10)
					if id == "@ID35ecf58" then
						table.insert(ecjam, v:interaction())
					end 
				end 
			end
			for _,v in pairs(ecjam) do v:interact(managers.player:player_unit()) end
			ChatMessage('All Security Doors Opened With ECM', 'MVP')
			enableinteract()
		end 
	end	
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- OPEN ALL PRESENTS (WHITE XMAS)
	function xmaspresent()
		InteractType({"hold_open_xmas_present"})
		ChatMessage('All Presents Opened', 'MVP')
	end	
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- PLACE FLARE (WHITE XMAS)
	function xmasflare()
		InteractType({'place_flare', 'ignite_flare'})
		ChatMessage('Flare Placed/Ignited', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- OPEN ALL DOORS WITH C4
	function c4open()
		enableinteract()
		InteractType({'c4_special', 'shaped_sharge', 'c4_diffusible'})
		enableinteract()
		ChatMessage('All Doors Blown With C4', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- COWER ALL CIVS (BY INFORMATIXA)
	function civilsdown(count)
		for _, data in pairs(managers.enemy:all_civilians()) do
			data.unit:brain():on_intimidated(100, managers.player:player_unit())
		end	
	end
	function civil()	
		for i = 1,20,1 do 
			civilsdown(i) 
		end
		ChatMessage('All Civilians Cowered', 'MVP')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- INSTANT WIN
	function jobwin()
		if isHost() then
			local num_winners = managers.network:game():amount_of_alive_players()
			managers.network:session():send_to_peers("mission_ended", true, num_winners)
			game_state_machine:change_state_by_name("victoryscreen", {num_winners = num_winners, personal_win = true})
		else
			ChatMessage('Host Only', 'MVP')
		end	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- INSTANT LOSS
	function jobloss()
		if isHost() then
			managers.network:session():send_to_peers("mission_ended", false, 0)
			game_state_machine:change_state_by_name("gameoverscreen")
		else
			ChatMessage('Host Only', 'MVP')
		end	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- SPAWN CONFIDANTIAL TRAIN HEIST INFO
	function heistintel()	
		if isHost() and (managers.job:current_level_id() == 'arm_hcm' or managers.job:current_level_id() == 'arm_cro' or managers.job:current_level_id() == 'arm_fac' or managers.job:current_level_id() == 'arm_par' or managers.job:current_level_id() == 'arm_und') then
			local position = managers.player:player_unit():position()
			local rotation = managers.player:player_unit():rotation()
			local unit = "units/payday2/props/gen_prop_loot_confidential_folder_event/gen_prop_loot_confidential_folder_event"
			World:spawn_unit(Idstring(unit), position, rotation)
			ChatMessage('Train Heist Intel Has Been Dropped', 'MVP')
		end	
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- BETTY BOOM MOD (EXPLODING AI)
	local function bettyboom()
		Toggle.BettyBoom = not Toggle.BettyBoom
	
		if not Toggle.BettyBoom then
			backuper:restore('CopActionHurt.on_death_drop')
			ChatMessage('Disabled', 'BOUNCING BETTY BOOM')
			return
		end
		
		ChatMessage('Enabled', 'BOUNCING BETTY BOOM')
		local CopActionHurt_on_death_drop = backuper:backup('CopActionHurt.on_death_drop')
		function CopActionHurt:on_death_drop(unit, stage)
			for i = 1,2 do
				ModBagSpawn('ammo', self._unit:position(), 120)
			end
			return CopActionHurt_on_death_drop(self, unit, stage)
		end
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- DIRTY MONEY MOD (SPAWNS GOLD ON AI DEATH)
	local function dirtymoney()
		Toggle.DirtyMoney = not Toggle.DirtyMoney
	
		if not Toggle.DirtyMoney then
			backuper:restore('CopActionHurt.on_death_drop')
			ChatMessage('Disabled', 'DIRTY MONEY')
			return
		end
		
		ChatMessage('Enabled', 'DIRTY MONEY')
		local CopActionHurt_on_death_drop = backuper:backup('CopActionHurt.on_death_drop')
		function CopActionHurt:on_death_drop(unit, stage)
			for i = 1,2 do
				ModBagSpawn('ammo', self._unit:position(), 120)
			end
			return CopActionHurt_on_death_drop(self, unit, stage)
		end
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- PARTY TIME
	function party()
		dofile('MVP/Main/InGameAssets/partyrockinv2.lua')
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- RATS AUTO COOKER (BALDWIN)
	function autocook()
		Toggle.auto_cooker = not Toggle.auto_cooker

		if not Toggle.auto_cooker then
			backuper:restore('DialogManager.queue_dialog')
			ChatMessage('Disabled', 'AUTO-COOKER')
			return
		end

		local cookinteract = function(drugs) --Needed for autocook.
			local coolers = {}
			local player = managers.player:local_player()
			if not player then return end
			for _,unit in pairs(managers.interaction._interactive_objects) do
				if unit:interaction().tweak_data == drugs then
					unit:interaction():interact(player)
					break --I'm sure, that here is only 1 interactive object
				end	
			end 
			if drugs == "taking_meth" then
				ServerSpawnRatBag("meth")
				managers.player:clear_carry()
			end	
		end

		ChatMessage('Enabled', 'AUTO-COOKER')
		backuper:hijack('DialogManager.queue_dialog', function(o, self, id, params)
			if id == "pln_rt1_22" then cookinteract("methlab_caustic_cooler")
			elseif id == "pln_rt1_20" then cookinteract("methlab_bubbling")
			elseif id == "pln_rt1_24" then cookinteract("methlab_gas_to_salt")
			elseif id == "pln_rat_stage1_28" or id == "pln_rat_stage1_29" then cookinteract("taking_meth")
			end
			return o(self, id, params )
		end)
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- MOUSE MODES --
	-- ACTION SETUP
	function setaction()
		Toggle.action = not Toggle.action
		if not Toggle.action then	
			ChatMessage('Disabled', 'MOUSE ACTION SETUP')
			UnbindKey(MVPConfig.MouseSlowMo)
			UnbindKey(MVPConfig.MouseTeleport)
		else
			ChatMessage('Enabled', 'MOUSE ACTION SETUP')
			BindKey(MVPConfig.MouseSlowMo, "MVP/Main/InGameAssets/Mouse Mod/SLOWMO.lua") 
			BindKey(MVPConfig.MouseTeleport, "MVP/Main/InGameAssets/Mouse Mod/PENETRATIVE TELEPORT.lua")
		end 
	end		 
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------		
	-- CONVERT SETUP
	function setmagus()
		Toggle.clone = not Toggle.clone 	
		if not Toggle.clone then	
			ChatMessage('Disabled', 'MOUSE CONVERT SETUP')
			UnbindKey(MVPConfig.MouseTeleport1)
			UnbindKey(MVPConfig.MouseConvert)
		else	
			ChatMessage('Enabled', 'MOUSE CONVERT SETUP')
			BindKey(MVPConfig.MouseTeleport1, "MVP/Main/InGameAssets/Mouse Mod/PENETRATIVE TELEPORT.lua") 
			BindKey(MVPConfig.MouseConvert, "MVP/Main/InGameAssets/Mouse Mod/xhairconverter.lua")
		end	
	end
-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
	MissionMenu = CustomMenuClass:new()
	MissionMenu:addMainMenu('main_menu', {title = 'Mission Manipulator Menu - Select Option', maxRows = 12})
	MissionMenu:addMenu('mod_menu', {title = 'Mod Menu - Select Option'})
	MissionMenu:addMenu('mouse_menu', {title = 'Mouse Mode Menu - Select Option'})
	
	MissionMenu:addInformationOption('main_menu', 'MENUS', {textColor = Color.red})
	-- Mod Menu Column 1
	MissionMenu:addMenuOption('main_menu', 'Mod Menu', 'mod_menu', {rectHighlightColor = Color.red})
	MissionMenu:addInformationOption('mod_menu', 'MODS', {textColor = Color.DodgerBlue})
	MissionMenu:addOption('mod_menu','Party-Time', {callback = party, help = 'Spawn A Party Of Civilians'})   
	MissionMenu:addGap('mod_menu') 
	MissionMenu:addInformationOption('mod_menu', 'TOGGLE MODS', {textColor = Color.DodgerBlue})
	MissionMenu:addToggleOption('mod_menu','Betty Boom Mod', {callback = bettyboom, help = 'Blows Up AI Upon Death'})  
	MissionMenu:addToggleOption('mod_menu','Dirty Money Drop', {callback = dirtymoney, help = 'Drops 2 Gold Bags Upon AI Death'})  
	if managers.job:current_level_id() == 'alex_1' then
		MissionMenu:addToggleOption('mod_menu','Rats Auto Cooker', {callback = autocook, help = 'Automates Cooking In Rats Day 1, Must Have Chemicals To Continue The Cooking'})  
	else
		MissionMenu:addInformationOption('mod_menu', 'Rats Day 1 Only', {textColor = Color.yellow})
	end
	for i=1,20 do
		MissionMenu:addGap('mod_menu')
    end
	
	-- Mouse Menu Column 1
	MissionMenu:addMenuOption('main_menu', 'Mouse Mode Menu', 'mouse_menu', {rectHighlightColor = Color.red})
	MissionMenu:addInformationOption('mouse_menu', 'MOUSE SETUP MODES', {textColor = Color.DodgerBlue}) 
	if MVPConfig.Mission_Manipulator_config and MVPConfig.Mouse_Action_Config then
		MissionMenu:addToggleOption('mouse_menu','Action Setup', {callback = setaction, help = 'User Defined Controls', toggle = true})
	else	
		MissionMenu:addToggleOption('mouse_menu','Action Setup', {callback = setaction, help = 'User Defined Controls'})
	end
	if MVPConfig.Mission_Manipulator_config and MVPConfig.Mouse_Convert_Config then	
		MissionMenu:addToggleOption('mouse_menu','Convert Setup', {callback = setmagus, help = 'User Defined Controls', toggle = true})
	else	
		MissionMenu:addToggleOption('mouse_menu','Convert Setup', {callback = setmagus, help = 'User Defined Controls'})
	end
	-- Main Menu Column 1
	MissionMenu:addGap('main_menu')
	MissionMenu:addInformationOption('main_menu', 'OPTIONS', {textColor = Color.DodgerBlue})
	MissionMenu:addOption('main_menu','Alert Civilians', {callback = civil, help = 'Intimidate All Civilians, Press Multiple Times To Get Down On Floor'})
	MissionMenu:addOption('main_menu','Board Up All Windows', {callback = instaboardst, help = 'Board Up All Available Windows'})
	if isHost() then
		if managers.job:current_level_id() == 'mus' then		
			MissionMenu:addOption('main_menu','Cut All Glass', {callback = cutglass})
		else	
			MissionMenu:addInformationOption('main_menu', 'The Diamond Only', {textColor = Color.yellow })
		end		
		if (managers.job:current_level_id() == 'arm_hcm' or managers.job:current_level_id() == 'arm_cro' or managers.job:current_level_id() == 'arm_fac' or managers.job:current_level_id() == 'arm_par' or managers.job:current_level_id() == 'arm_und') then		
			MissionMenu:addOption('main_menu','Drop Train Heist Intel', {callback = heistintel, help = 'Can Only Drop In Transport Heists'})
		else	
			MissionMenu:addInformationOption('main_menu', 'Tranport Missions Only', {textColor = Color.yellow })
		end
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	MissionMenu:addOption('main_menu','Get Item/Continue Mission', {callback = getpatht, help = 'Must Enable CarryStacker, Grabs All Necessary Items To Continue Mission'})
	if isHost() then
		MissionMenu:addOption('main_menu','Grab All Gage Packages', {callback = grabcourier, help = 'Grab All Available Gage Packages'})
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	MissionMenu:addOption('main_menu','Hack All Electrics', {callback = InstantHackAll , help = 'Hack Available Computers, Keypads, Phones Or Electrical Boxes'})

	-- Main Menu Column 2
	MissionMenu:addInformationOption('main_menu', 'ANTI-CHEAT TOGGLE', {textColor = Color.DodgerBlue})
	if isHost() then
		if MVPConfig.Anti_Cheat_Disable then
			MissionMenu:addToggleOption('main_menu','Disable Anti-Cheat', {callback = anticheat, toggle = true, help = 'Enable or Disable Anti-Cheats For Host And Client'})
		else	
			MissionMenu:addToggleOption('main_menu','Disable Anti-Cheat', {callback = anticheat, toggle = false, help = 'Enable or Disable Anti-Cheats For Host And Client'})
		end
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	MissionMenu:addGap('main_menu')	
	MissionMenu:addGap('main_menu')
	MissionMenu:addGap('main_menu')
	if isHost() then
		if managers.job:current_level_id() == "mus" then
			MissionMenu:addOption('main_menu','Instant Grab Diamond', {callback = GrabDiamond, help = 'Press Twice To Grab Diamond'})
		else	
			MissionMenu:addInformationOption('main_menu', 'The Diamond Only', {textColor = Color.yellow})
		end
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	if isHost() then
		if managers.job:current_level_id() == "election_day_2" then
			MissionMenu:addOption('main_menu','Instant Hack & Open Voting Machines', {callback = instanthackmachines})
		else	
			MissionMenu:addInformationOption('main_menu', 'Election Day Warehouse Only', {textColor = Color.yellow})
		end
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	MissionMenu:addOption('main_menu','Open All Crates', {callback = opencrate, help = 'You Can Close Available Crates Also'})
	MissionMenu:addOption('main_menu','Open All Deposit Boxes', {callback = bankbuster})
	MissionMenu:addOption('main_menu','Open All Doors & Windows', {callback = picklockst, help = 'This Does Not Open Security Doors'})
	if isHost() then
		MissionMenu:addOption('main_menu','Open All Doors & Safes With C4', {callback = c4open})
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow })
	end
	if managers.job:current_level_id() == 'pines' then
		MissionMenu:addOption('main_menu','Open All Presents', {callback = xmaspresent})
	else
		MissionMenu:addInformationOption('main_menu', 'White Xmas Only', {textColor = Color.yellow})
	end
	
	-- Main Menu Column 3
	MissionMenu:addInformationOption('main_menu', 'WIN/LOSS OPTIONS', {textColor = Color.DodgerBlue}) 
	if isHost() then
		MissionMenu:addOption('main_menu','Instant Loss', {callback = jobloss, closeMenu = true})
		MissionMenu:addOption('main_menu','Instant Win', {callback = jobwin, closeMenu = true})
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	MissionMenu:addGap('main_menu')
	MissionMenu:addGap('main_menu')
	if isHost() then
		MissionMenu:addOption('main_menu','Open Security Doors With ECM', {callback = ecmopen})
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow})
	end
	MissionMenu:addOption('main_menu','Open Security Doors With Keycard', {callback = usekeycardt})
	if managers.job:current_level_id() == 'pines' then	
		MissionMenu:addOption('main_menu','Place/Ignite Flare', {callback = xmasflare})
	else
		MissionMenu:addInformationOption('main_menu', 'White Xmas Only', {textColor = Color.yellow})
	end
	if isHost() then
		MissionMenu:addOption('main_menu','Start/Restart Drill(s)', {callback = DrillAll, help = 'Start or Restart Any Available Drill'})
	else
		MissionMenu:addInformationOption('main_menu', 'Not Available (Host Only)', {textColor = Color.yellow })
	end
	MissionMenu:addOption('main_menu','Tie All Civilians', {callback = instanttie, help = 'Must Alert All Civilians Before Activating'})
end
-----------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------
if inGame() and isPlaying() then
	if MissionMenu:isOpen() then
		MissionMenu:close()
	else
		if ChangerMenu then
			if ChangerMenu:isOpen() then
				ChangerMenu:close()
			end	
		end
		if PlayerMenu then
			if PlayerMenu:isOpen() then
				PlayerMenu:close()
		end	end		
		if StealthMenu then
			if StealthMenu:isOpen() then
				StealthMenu:close()
			end	
		end		
		if InventoryMenu then
			if InventoryMenu:isOpen() then
				InventoryMenu:close()
			end	
		end
		if MoneyMenu then
			if MoneyMenu:isOpen() then
				MoneyMenu:close()
			end	
		end
		if NumpadMenu then
			if NumpadMenu:isOpen() then
				NumpadMenu:close()
			end	
		end
		if InteractTimerMenu then	
			if InteractTimerMenu:isOpen() then
				InteractTimerMenu:close()
			end	
		end		
		MissionMenu:open()
	end 
end