require 'MVP/Main/InGameAssets/rainbags'

if not InventoryMenu then 
	-- SPAWN BAG
	function spawn_bag(name)
		if Toggle.is_rain then
			return RainBags(name, 100)		
		elseif Toggle.is_self then
			return GiveBag(name)
		elseif Toggle.is_cross then
			return ServerSpawnBagCrossHair(name)
		end
		ServerSpawnBag(name)
	end
	---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------			
	-- ADD ITEM
	function add_item(name)
		managers.player:add_special({name = name, silent = true, amount = 1})
	end
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------------------------
	InventoryMenu = CustomMenuClass:new()
	InventoryMenu:addMainMenu('main_menu', {title = 'Inventory Menu - Select Option'})
	InventoryMenu:addMenu('add_items_menu', {title = 'Add Items Menu - Select Item'})
	InventoryMenu:addMenu('loot_menu', {title = 'Loot Bag Menu - Select Bag'})
	InventoryMenu:addMenu('equipment_menu', {title = 'Equipment Bag Menu - Select Bag'})
	InventoryMenu:addMenu('engine_menu', {title = 'Big Oil Engine Menu - Select Engine'})

	-- Inventory Main Menu
	InventoryMenu:addInformationOption('main_menu', 'ADD INVENTORY ITEMS MENU', {textColor = Color.red })
	InventoryMenu:addMenuOption('main_menu','Add Inventory Items Menu', 'add_items_menu', {rectHighlightColor = Color.red})
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addInformationOption('main_menu', 'SPAWN BAG MENUS', { textColor = Color.red })	
	InventoryMenu:addMenuOption('main_menu','Big Oil Engine Menu', 'engine_menu', {rectHighlightColor = Color.red})
	InventoryMenu:addOption('engine_menu', 'Engine 01', {callback = spawn_bag, callbackData = 'engine_01'})
	InventoryMenu:addOption('engine_menu', 'Engine 02', {callback = spawn_bag, callbackData = 'engine_02'})
	InventoryMenu:addOption('engine_menu', 'Engine 03', {callback = spawn_bag, callbackData = 'engine_03'})
	InventoryMenu:addOption('engine_menu', 'Engine 04', {callback = spawn_bag, callbackData = 'engine_04'})
	InventoryMenu:addOption('engine_menu', 'Engine 05', {callback = spawn_bag, callbackData = 'engine_05'})
	InventoryMenu:addOption('engine_menu', 'Engine 06', {callback = spawn_bag, callbackData = 'engine_06'})
	InventoryMenu:addOption('engine_menu', 'Engine 07', {callback = spawn_bag, callbackData = 'engine_07'})
	InventoryMenu:addOption('engine_menu', 'Engine 08', {callback = spawn_bag, callbackData = 'engine_08'})
	InventoryMenu:addOption('engine_menu', 'Engine 09', {callback = spawn_bag, callbackData = 'engine_09'})
	InventoryMenu:addOption('engine_menu', 'Engine 10', {callback = spawn_bag, callbackData = 'engine_10'})
	InventoryMenu:addOption('engine_menu', 'Engine 11', {callback = spawn_bag, callbackData = 'engine_11'})
	InventoryMenu:addOption('engine_menu', 'Engine 12', {callback = spawn_bag, callbackData = 'engine_12'})
	
	InventoryMenu:addMenuOption('main_menu','Equipment Bag Menu', 'equipment_menu', {rectHighlightColor = Color.red})
	InventoryMenu:addOption('equipment_menu', 'Body Bag', {callback = spawn_bag, callbackData = 'person'})
	InventoryMenu:addOption('equipment_menu', 'Cage', {callback = spawn_bag, callbackData = 'cage_bag'})
	InventoryMenu:addOption('equipment_menu', 'FBI Server', {callback = spawn_bag, callbackData = 'circuit'})
	if managers.job:current_level_id() == 'crojob2' or managers.job:current_level_id() == 'crojob2_night' or managers.job:current_level_id() == 'crojob3' or managers.job:current_level_id() == 'crojob3_night' then	
		InventoryMenu:addOption('equipment_menu', 'Ladder', {callback = spawn_bag, callbackData = 'ladder_bag'})
	end
	InventoryMenu:addOption('equipment_menu', 'The Beast', {callback = spawn_bag, callbackData = 'lance_bag_large'})
	InventoryMenu:addOption('equipment_menu', 'Thermal Drill', {callback = spawn_bag, callbackData = 'lance_bag'})
	InventoryMenu:addOption('equipment_menu', 'Tool Bag', {callback = spawn_bag, callbackData = 'equipment_bag'})
	
	InventoryMenu:addMenuOption('main_menu','Loot Bag Menu', 'loot_menu', {rectHighlightColor = Color.red})
	InventoryMenu:addOption('loot_menu', 'Almirs Toast Bag', {callback = spawn_bag, callbackData = 'sandwich'})
	InventoryMenu:addOption('loot_menu', 'Ammo', {callback = spawn_bag, callbackData = 'ammo'})
	InventoryMenu:addOption('loot_menu', 'Artifact Statue', {callback = spawn_bag, callbackData = 'artifact_statue'})
	InventoryMenu:addOption('loot_menu', 'Bomb Part', {callback = spawn_bag, callbackData = 'cro_loot1'})
	InventoryMenu:addOption('loot_menu', 'Bomb Part 2', {callback = spawn_bag, callbackData = 'cro_loot2'})
	InventoryMenu:addOption('loot_menu', 'Cocaine', {callback = spawn_bag, callbackData = 'coke'})
	InventoryMenu:addOption('loot_menu', 'Diamonds/Jewelry', {callback = spawn_bag, callbackData = 'diamonds'})
	InventoryMenu:addOption('loot_menu', 'Gold', {callback = spawn_bag, callbackData = 'gold'})
	InventoryMenu:addOption('loot_menu', 'Grenade Bag', {callback = spawn_bag, callbackData = 'grenades'})
	InventoryMenu:addOption('loot_menu', 'Meth', {callback = spawn_bag, callbackData = 'meth'})
	InventoryMenu:addOption('loot_menu', 'Money', {callback = spawn_bag, callbackData = 'money'})
	InventoryMenu:addOption('loot_menu', 'Museum Artifact', {callback = spawn_bag, callbackData = 'mus_artifact'})
	InventoryMenu:addOption('loot_menu', 'Museum Painting', {callback = spawn_bag, callbackData = 'mus_artifact_paint'})
	InventoryMenu:addOption('loot_menu', 'Painting', {callback = spawn_bag, callbackData = 'painting'})
	InventoryMenu:addOption('loot_menu', 'Pure Cocaine', {callback = spawn_bag, callbackData = 'coke_pure'})
	InventoryMenu:addOption('loot_menu', 'Samurai Suit', {callback = spawn_bag, callbackData = 'samurai_suit'})
	InventoryMenu:addOption('loot_menu', 'The Diamond', {callback = spawn_bag, callbackData = 'hope_diamond'})
	InventoryMenu:addOption('loot_menu', 'Turret', {callback = spawn_bag, callbackData = 'turret'})
	InventoryMenu:addOption('loot_menu', 'Weapons', {callback = spawn_bag, callbackData = 'weapon'})
	

	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addInformationOption('main_menu', 'SPAWN OPTIONS', {textColor = Color.DodgerBlue })
	InventoryMenu:addToggleOption('main_menu', 'Give Bag To Self', {callback = function() Toggle.is_self = not Toggle.is_self end })
	InventoryMenu:addToggleOption('main_menu', 'Rain Bags', {callback = function() Toggle.is_rain = not Toggle.is_rain end, help = 'Do Not Spam, Will Cause Crash' })
	InventoryMenu:addToggleOption('main_menu', 'Spawn On Crosshair', {callback = function() Toggle.is_cross = not Toggle.is_cross end })
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addGap('main_menu')
	InventoryMenu:addInformationOption('main_menu', 'BAG OPTIONS', {textColor = Color.DodgerBlue })
	InventoryMenu:addOption('main_menu', 'Bag All Bodies', {callback = InteractType, callbackData = {'corpse_dispose'}, help = 'Bags Bodies Only'})
	InventoryMenu:addOption('main_menu', 'Pick Up All Bags', {callback = InteractType, callbackData = {'carry_drop', 'painting_carry_drop'}, help = 'CarryStacker Must Be Enabled Or Bags Will Get Deleted'})

	InventoryMenu:addInformationOption('add_items_menu', 'ITEMS', {textColor = Color.DodgerBlue})
	InventoryMenu:addOption('add_items_menu','Bank Manager Key(Keycard)', {callback = add_item, callbackData = 'bank_manager_key'})
	InventoryMenu:addOption('add_items_menu','Blood Sample', {callback = add_item, callbackData = 'blood_sample'})
	InventoryMenu:addOption('add_items_menu','Boards', {callback = add_item, callbackData = 'boards'})
	InventoryMenu:addOption('add_items_menu','C4', {callback = add_item, callbackData = 'c4'})
	InventoryMenu:addOption('add_items_menu','Cable-Tie', {callback = add_item, callbackData = 'cable_tie'})
	InventoryMenu:addOption('add_items_menu','Chavez Key', {callback = add_item, callbackData = 'chavez_key'})
	InventoryMenu:addOption('add_items_menu','Crowbar', {callback = add_item, callbackData = 'crowbar'})
	InventoryMenu:addOption('add_items_menu','Gas Can', {callback = add_item, callbackData = 'gas'})
	InventoryMenu:addOption('add_items_menu','Glass Cutter', {callback = add_item, callbackData = 'mus_glas_cutter'})
	
	InventoryMenu:addGap('add_items_menu')
	InventoryMenu:addOption('add_items_menu','Keychain', {callback = add_item, callbackData = 'keychain'})
	InventoryMenu:addOption('add_items_menu','Lance', {callback = add_item, callbackData = 'lance'})
	InventoryMenu:addOption('add_items_menu','Lance Part', {callback = add_item, callbackData = 'lance_part'})
	InventoryMenu:addOption('add_items_menu','Organs', {callback = add_item, callbackData = 'organs'})
	InventoryMenu:addOption('add_items_menu','Planks', {callback = add_item, callbackData = 'planks'})
	InventoryMenu:addOption('add_items_menu','Thermite Paste', {callback = add_item, callbackData = 'thermite_paste'})
	InventoryMenu:addGap('add_items_menu')
	InventoryMenu:addGap('add_items_menu')
	InventoryMenu:addGap('add_items_menu')
	
	InventoryMenu:addInformationOption('add_items_menu', 'RATS/HOTLINE MIAMI CHEMICALS', {textColor = Color.DodgerBlue})
	InventoryMenu:addOption('add_items_menu','Caustic Soda', {callback = add_item, callbackData = 'caustic_soda'})
	InventoryMenu:addOption('add_items_menu','Hydrogen Chloride', {callback = add_item, callbackData = 'hydrogen_chloride'})
	InventoryMenu:addOption('add_items_menu','Muriatic Acid', {callback = add_item, callbackData = 'acid'})	
	InventoryMenu:addInformationOption('add_items_menu', 'HOTLINE MIAMI BARCODES', {textColor = Color.DodgerBlue})
	InventoryMenu:addOption('add_items_menu','Downtown Barcode', {callback = add_item, callbackData = 'barcode_downtown'})
	InventoryMenu:addOption('add_items_menu','Foggy Bottom Barcode', {callback = add_item, callbackData = 'barcode_isles_beach'})
	InventoryMenu:addOption('add_items_menu','George Town Barcode', {callback = add_item, callbackData = 'barcode_brickell'})		
	InventoryMenu:addOption('add_items_menu','Shaw Barcode', {callback = add_item, callbackData = 'barcode_opa_locka'})	
	InventoryMenu:addOption('add_items_menu','West End Barcode', {callback = add_item, callbackData = 'barcode_edgewater'})
	
	InventoryMenu:addInformationOption('add_items_menu', 'HOXTON BREAKOUT ITEMS', {textColor = Color.DodgerBlue})
	InventoryMenu:addOption('add_items_menu','Bridge ', {callback = add_item, callbackData = 'bridge'})
	InventoryMenu:addOption('add_items_menu','Evidence', {callback = add_item, callbackData = 'evidence'})
	InventoryMenu:addOption('add_items_menu','Files', {callback = add_item, callbackData = 'files'})	
	InventoryMenu:addOption('add_items_menu','Hard Drive', {callback = add_item, callbackData = 'harddrive'})
	InventoryMenu:addOption('add_items_menu','Ticket', {callback = add_item, callbackData = 'ticket'})
end
	
if inGame() and isPlaying() then
	if InventoryMenu:isOpen() then
		InventoryMenu:close()
	else
		if ChangerMenu then
			if ChangerMenu:isOpen() then
				ChangerMenu:close()
			end	
		end
		if PlayerMenu then
			if PlayerMenu:isOpen() then
				PlayerMenu:close()
			end	
		end	
		if StealthMenu then
			if StealthMenu:isOpen() then
				StealthMenu:close()
			end	
		end	
		if MissionMenu then
			if MissionMenu:isOpen() then
				MissionMenu:close()
			end	
		end
		if MoneyMenu then
			if MoneyMenu:isOpen() then
				MoneyMenu:close()
			end	
		end
		if NumpadMenu then
			if NumpadMenu:isOpen() then
				NumpadMenu:close()
			end	
		end
		if InteractTimerMenu then	
			if InteractTimerMenu:isOpen() then
				InteractTimerMenu:close()
			end	
		end	
		InventoryMenu:open()
	end 
end