function restartpro()	
	local _oldIsProfessional = JobManager.is_current_job_professional
	local _newIsProfessional =
		function(self) return false
	end

	local _lobbyStateEnter = IngameLobbyMenuState.at_enter 
	function IngameLobbyMenuState:at_enter()
		JobManager.is_current_job_professional = _newIsProfessional
		_lobbyStateEnter(self)
		JobManager.is_current_job_professional = _oldIsProfessional
	end
	
	local _lobbyContinue = GameOverState.continue
	function GameOverState:continue()
		JobManager.is_current_job_professional = _newIsProfessional
		_lobbyContinue(self)
		JobManager.is_current_job_professional = _oldIsProfessional
	end
	
	local _lobbyShutDownNetwork = GameOverState._shut_down_network
	function GameOverState:_shut_down_network( ... )
		JobManager.is_current_job_professional = _newIsProfessional
		_lobbyShutDownNetwork(self, ...)
		JobManager.is_current_job_professional = _oldIsProfessional
	end
	
	local _lobbyLoadStartMenu = GameOverState._load_start_menu
	function GameOverState:_load_start_menu( ... )
		JobManager.is_current_job_professional = _newIsProfessional
		_lobbyLoadStartMenu(self, ...)
		JobManager.is_current_job_professional = _oldIsProfessional
	end
	
	local _lobbySetBtnText = GameOverState._set_continue_button_text
	function GameOverState:_set_continue_button_text()
		JobManager.is_current_job_professional = _newIsProfessional
		_lobbySetBtnText(self)
		JobManager.is_current_job_professional = _oldIsProfessional
	end
	
	function MenuCallbackHandler:singleplayer_restart()
		return true
	end	
end