require 'MVP/UserConfig/Config'

-- BULLET PENETRATION ALL WEAPONS
if MVPConfig.Bullet_Penetration then	
	local old_init = WeaponTweakData.init

	function WeaponTweakData:init(tweak_data)
		old_init(self, tweak_data)
		
		for k,v in pairs(self) do
			if type(v) == "table" and v.category then
				self[k].can_shoot_through_shield = MVPConfig.Bullet_Penetration_Shield
				self[k].can_shoot_through_enemy = MVPConfig.Bullet_Penetration_Enemy
				self[k].can_shoot_through_wall = MVPConfig.Bullet_Penetration_Wall
			end	
		end 
	end 
end