require 'MVP/Main/PostRequire/Tools/ConfigTools' -- DO NOT REMOVE OR EDIT

--[[ 
-- GUI MENU/LASER COLOR OPTIONS --
-- LIST OF COLORS TO BE USED IN GUI MENU OPTIONS AND WEAPON LASER
AliceBlue, AntiqueWhite, Aqua, Aquamarine, Azure, Beige, Bisque, BlanchedAlmond, BlueViolet, Brown, BurlyWood, CadetBlue,
Chartreuse, Chocolate, Coral, CornflowerBlue, Cornsilk, Crimson , Cyan, DarkBlue, DarkCyan, DarkGoldenRod, DarkGray,
DarkGreen, DarkKhaki, DarkMagenta, DarkOliveGreen, DarkOrange, DarkOrchid, DarkRed, DarkSalmon, DarkSeaGreen, DarkSlateBlue, 
DarkSlateGray, DarkTurquoise, DarkViolet, DeepPink, DeepSkyBlue, DimGray, DodgerBlue, FireBrick, ForestGreen, Fuchsia, Gainsboro, 
Gold, GoldenRod, Gray, GreenYellow, HoneyDew, HotPink, IndianRed, Indigo, Khaki, Lavender, LavenderBlush, LawnGreen, LemonChiffon, LightBlue, 
LightCoral, LightCyan, LightGoldenRodYellow, LightGray, LightGreen, LightPink, LightSalmon, LightSeaGreen, LightSkyBlue, LightSlateGray,
LightSteelBlue, LightYellow, Lime, LimeGreen, Linen, Magenta, Maroon, MediumAquaMarine, MediumBlue, MediumOrchid, MediumPurple, MediumSeaGreen,
MediumSlateBlue, MediumSpringGreen, MediumTurquoise, MediumVioletRed, MidnightBlue, MintCream, MistyRose, Moccasin, Navy, OldLace, 
Olive, OliveDrab, Orange, OrangeRed, Orchid, PaleGoldenRod, PaleGreen, PaleTurquoise, PaleVioletRed, PapayaWhip, PeachPuff, Peru, Pink, Plum, 
PowderBlue, RosyBrown, RoyalBlue, SaddleBrown, Salmon, SandyBrown, SeaGreen, SeaShell, Sienna, Silver, SkyBlue, SlateBlue, 
SlateGray, SpringGreen, SteelBlue, Tan, Teal, Thistle, Tomato, Turquoise, Violet, Wheat, YellowGreen
--------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- BAG SPAWN OPTIONS --
-- LIST OF BAG SPAWNS TO BE USED WITH NUMPAD SPAWNS
Almirs_Toast, Artifact, The_Beast, Body_Bag, Coke, Coke_Pure, Diamond, Gold, Jewelry, Meth, Money, Museum_Artifact, Museum_Painting, 
Painting, Samurai_Armor, FBI_Server, Thermal_Drill, Tool, Turret, Turret_Ammo

-- BIG OIL ENGINES
Engine_01, Engine_02, Engine_03, Engine_04, Engine_05, Engine_06, Engine_07, Engine_08, Engine_09, Engine_10, Engine_11, Engine_12
--------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- MOUSE BIND OPTIONS --
-- LIST OF KEYBINDS TO BE USED WITH MOUSE MODES
MiddleMouseButton, SideButton1, SideButton2 
]]
--------------------------------------------------------------------------------------------------------------------------------------------------------------------
--[[ 
-- MVP CONFIG --
Configure All Your Options Here
true = On, false = Off
]]
MVPConfig = {	
	----------------------
	-- GUI MENU OPTIONS --
	----------------------
	Title_Menu_Color = Color.black, -- Title Menu Border Color
	Main_Menu_Color = Color.black, -- Main Menu Border Color
	Navigation_Menu_Color = Color.black, -- Navigation Menu Border Color	
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	------------------
	-- MAIN OPTIONS --
	------------------
	-- DLC UNLOCKER -- (REQUIRES RESTART TO TAKE EFFECT)
	DLC_Unlocker = true, -- Unlock All DLC (Master Control)(Cheater Detected)
	
	-- AUTO PICK RANDOM CARD -- (REQUIRES RESTART TO TAKE EFFECT)
	Auto_Pick_Card = false, -- Auto Select Random Card In Loot Drop Screen
	
	-- AUTO GADGET -- (REQUIRES RESTART TO TAKE EFFECT)
	Auto_Gadget = false, -- Auto Turn On Weapon Gadget Upon Weapon Switching When Gadget Is On	
	
	-- DROP-IN PAUSE REMOVE -- (REQUIRES RESTART TO TAKE EFFECT)
	Dropin_Pause_Remove = false, -- Remove The Drop-In Pause When Players Are Joining
	
	-- FORCE ANY SKILL -- (REQUIRES RESTART TO TAKE EFFECT)
	-- Do Not Duplicate Skills, Remove Skills You Have Owned Already Or Will Result In Crash
	Force_Skills = false, -- Force Selection Of Skills (Edit Skills In 'MVP/Main/PostRequire/ForceSkill', Refer To 'MVP/Main/Info Resources/SkillsList' For Info On Skills)

	-- FREE PURCHASES MANAGER -- (REQUIRES RESTART TO TAKE EFFECT)
	Free_Assets = false, -- Free Asset Purchases 
	Free_Casino = false, -- Free Casino Purchases
	Free_Contracts = false, -- Free Contract Purchases
	Free_Masks = false, -- Free Mask Purchases
	Free_PrePlanning = false, -- Free PrePlanning Purchases
	Free_Skills = false, -- Free Skill Purchases
	Free_Slots = false, -- Free Weapon/Mask Slot Purchases
	Free_Weapons = false, -- Free Weapon Purchases
	
	-- LAZY HUD -- (REQUIRES LEVEL RESTART TO TAKE EFFECT)
	Lazy_Hud = false, -- Custom Hud Made By LazyOzzy
	Lazy_Show_Timer = false, -- Drills, Timelocks, Hacking etc.
	Lazy_Show_Equipment = false, -- Deployables (Ammo, Doc Bags, Body Bags)
	Lazy_Show_Minions = false, -- Converted Enemies, Type And Health
	Lazy_Show_Pagers = false, -- Active Pagers
	Lazy_Show_ECMS = false, -- Active ECMs
	Lazy_Show_Enemies = false, -- Currently Spawned Enemies
	Lazy_Aggregate_Enemies = false, -- Don't Split Enemies On Type; Use A Single Entry For All
	Lazy_Show_Hostages = false, -- Currently Spawned, Untied Civilians
	Lazy_Show_Buffs = false, -- Active Effects (Buffs/Debuffs)
	Lazy_Show_Loot = false, -- Show Spawned And Active Loot Bags/Piles (May Not Be Shown If Certain Mission Parameters Has Not Been Met)
	Lazy_Aggregate_Loot = false, -- Don't Split Loot On Type; Use A Single Entry For All
	
	-- NO JOB HEAT -- (REQUIRES RESTART TO TAKE EFFECT)
	No_Job_Heat = false, -- Disable Repeated Job Penalties (Master Control)
	Job_Heat_Amount = 1.20, -- Set Job Heat Bonus Amount (Default 1.15 = 15%)
		
	-- RATS MESSAGE DISPLAY -- (REQUIRES RESTART TO TAKE EFFECT)
	Rats_Message = false, -- Display Correct Chemical In Chat Message In Rats Day 2	
	
	-- RESTART PRO JOBS -- (REQUIRES RESTART TO TAKE EFFECT)
	Restart_Pro = false, -- Enable Restarting In Pro Jobs 
	
	-- STEALTH INPSIRE -- (REQUIRES RESTART TO TAKE EFFECT)
	Stealth_Shout_Inspire = false, -- Shout Revive and Inspire While Still In Stealth	
	
	-- SKIP END SCREEN -- (REQUIRES RESTART TO TAKE EFFECT)
	Skip_End_Screen = false, -- Allows You To Skip End Screen
	
	-- WEAPON TWEAKS -- (REQUIRES RESTART TO TAKE EFFECT)
	Bullet_Penetration = false, -- Bullet Penetration On All Guns Excluding Shotguns (Master Control)(Choose Penetration Below)
	Bullet_Penetration_Enemy = false, -- Shoot Through Enemies
	Bullet_Penetration_Shield = false, -- Shoot Through Shields
	Bullet_Penetration_Wall = false, -- Shoot Through Walls
	Weapon_Laser = false, -- Custom Defined Weapon Laser (Master Control)
	Weapon_Laser_Color = Color.OrangeRed, -- Weapon Laser Color
	
	-- WEAPON/MASK ROW INCREASE -- (REQUIRES RESTART TO TAKE EFFECT)
	MaxMaskRows = 100, -- Increase Mask Row Count
	MaxWeaponRows = 100, -- Increase Weapon Row Count
		
	-- ZIPLINE CARRY DROP -- (REQUIRES RESTART TO TAKE EFFECT)
	Zipline_Drop = false, -- Drop Bags That You Are Carrying While On Zip-line (Master Control)
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	----------------------------
	-- KEYBIND/NUMPAD OPTIONS --
	----------------------------	
	-- AUTO ON OPTIONS 
	Keyboard_Auto_Config = false, -- Auto Run Key Binds (AUTO ON MASTER CONTROL)
	X_Ray = false, -- Outline Enemies, Civilians and Cams; Bound To 'X' (AUTO ON CONTROL)
	
	-- TURN ON/OFF KEYBINDS HERE, SET KEYBIND OPTION IF AVAILABLE
	-- AUTO ON DOES NOT APPLY HERE
	-- AMMO AND HEALTH REPLENISH (Z) --
	Full_Replenish = true, -- Replenish Health, Ammo And Reset State
	
	-- AMMO REPLENISH (C) --
	Ammo_Replenish = true, -- Replenish Ammo
	
	-- GRENADE SPAWN (B) --
	Grenade_Spawn = false, -- Spawn Grenades 
	Grenade_Spawn_Type = 'frag', -- Set Grenade Type ('frag' = Grenade, 'launcher_frag' = M79 Grenade)(Cheater Detected)
	
	-- HUD TOGGLE (F10) --
	Hud_Toggle = true, -- Toggle To Hide/Show InGame HUD
	
	-- RESTART JOB (NUMPAD /) --
	Restart_Job = true, -- Instant Restart Job (Host Only)
	
	-- SPAWN GAGE PACKAGE (\) --
	Gage_Package = false, -- Spawn Random Gage Package On Cross-hair
	
	-- ULTIMATE KILL (NUMPAD *) --
	Ultimate_Kill = true, -- Instant Kill All AI, If You're Host Pagers And Cams Are Disabled To Be More Effective 
	
	-- NUMPAD LOOT SPAWNS --
	-- SET BAG SPAWN FOR EACH KEY --
	Numpad_Loot_Spawn = true, -- Enable/Disable Numpad Spawns
	Numpad_Loot_Spawn_0 = Diamond, -- Numpad 0
	Numpad_Loot_Spawn_1 = Turret_Ammo,   -- Numpad 1
	Numpad_Loot_Spawn_2 = Museum_Painting, -- Numpad 2
	Numpad_Loot_Spawn_3 = Weapon, -- Numpad 3
	Numpad_Loot_Spawn_4 = Gold, -- Numpad 4
	Numpad_Loot_Spawn_5 = Money, -- Numpad 5
	Numpad_Loot_Spawn_6 = Jewelry, -- Numpad 6
	Numpad_Loot_Spawn_7 = Coke_Pure, -- Numpad 7
	Numpad_Loot_Spawn_8 = Meth, -- Numpad 8
	Numpad_Loot_Spawn_9 = Painting, -- Numpad 9
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	---------------------
	-- PREGAME OPTIONS --
	---------------------
	-- AUTO ON CHEATS -- (REQUIRES RESTART TO TAKE EFFECT)
	Auto_Cheats = false, -- Auto On Cheats, Selection Of Cheats To Be Active In Game (Auto On Control)	
	Bag_CoolDown = false, -- No Bag CoolDown
	Camera_Bag_Explosion_Multiplier = false, -- Explosive Bag Camera Effect Multiplier 
	Camera_Bag_Explosion_Multiplier_Amount = 0, -- Explosive Bag Camera Effect Multiplier Amount (Default 4)
	Explosion_Buff = false, -- All Explosions Damage Buff
	Explosion_Buff_Amount = 500, -- All Explosions Damage Buff Amount
	Fast_Mask = false, -- Fast Mask
	Grenade_Buff = false, -- Grenade Damage Buff
	Grenade_Buff_Damage_Amount = 300, -- Grenade Damage Buff Amount (Default 30)
	Grenade_Buff_Player_Damage_Amount = 10, -- Grenade Player(Self) Damage Amount (Default 10)
	Grenade_Buff_Range_Amount = 1200, -- Grenade Damage Buff Range Amount (Default 1000)
	Infinite_Hostage_Follow = false, -- Infinite Amount Of Following Hostages
	Infinite_Stamina = false, -- Infinite Stamina
	Jump_Mask_Off = false, -- Jump With Mask Off
	Lowered_Headbob = false, -- Lowered Head-bob
	Melee_Buff = false, -- Melee Damage Buff
	Melee_Buff_Amount = 1000, -- Melee Damage Buff Multiplier Amount
	No_FlashBang = false, -- No FlashBangs
	No_Recoil = false, -- No Weapon Recoil
	No_Spread = false, -- No Weapon Spread (Excludes Shotguns)
	Unlimited_BodyBags = false, -- Unlimited BodyBags
	
	-- XP MULTIPLIER -- (REQUIRES RESTART TO TAKE EFFECT)
	XP_Multiplier = false, -- XP Multiplier (Auto On Control)
	XP_Multiplier_Amount = 2, -- XP Multiplier Amount (Must Set For InGame Toggle)

	-- AUTO LOOT/EQUIPMENT -- (REQUIRES RESTART TO TAKE EFFECT)
	Auto_Loot = false, -- Spawn Randomized Extra Loot On Available Maps (Host Only) (Auto On Control)
	Auto_Equipment = false, -- Spawn Randomized Extra Keycards On Available Maps (Host Only) (Auto On Control)
	
	-- SECURE BODYBAGS FOR CASH -- (REQUIRES RESTART TO TAKE EFFECT)
	Secure_BodyBags = false, -- Secure Body Bags For Cash (Host Only) (Auto On Control)
	Secure_BodyBags_Loot_Value = 1000, -- Secure Body Bags For Cash Value Amount (Must Set For InGame Toggle)
	
	-- TOGGLE INTERACT -- (REQUIRES RESTART TO TAKE EFFECT)
	Toggle_Interact = false, -- Interact Toggle (Auto On Control)
	
	-- OTHER PREGAME OPTIONS -- (REQUIRES RESTART TO TAKE EFFECT)
	Grenade_Restrict = false, -- Restrict Grenades Being Thrown While In Stealth (Auto On Control)
	Loot_Value_Mod = false, -- Loot Value Modifier (Edit Loot Values In 'MVP/UserConfig/LootModConfig') (Host Only) (Auto On Control)
	Pager_Mod = false, -- Increase Pager Count On Available Maps (Host Only) (Auto On Control)
	Upgrade_Tweaks = false, -- Custom Selection of Upgrade Tweaks (Edit In 'MVP/UserConfig/UpgradeTweakConfig') (Host Only) (Auto On Control)
	-------------------------------------------------------------------------------------------------------------------------------------------------------------------------	
	----------------------
	-- PLAYER MENU (F1) --
	----------------------	
	-- PLAYER MENU OPTIONS --
	Player_Menu_Config = false, -- Player Menu (Auto On Master Control)
	Auto_Drill_Service = false, -- Auto Drill Service (Restores Drills Automatically)
	Carry_Mod = false, -- Remove Bag Weight And All Explosive Properties 
	Carry_Stacker = false, -- Carry Multiple Bags
	Cloakers_Cuff_Self = false, -- Cloakers Cuff You When Attacking
	Friendly_Fire = false, -- Enable Friendly Fire (Converts, Team AI)
	God_Mode = false, -- God Mode
	Infinite_Ammo = false, -- Infinite Ammo
	Infinite_Ammo_Bag = false, -- Infinite Ammo Bag Uses
	Infinite_Converts = false, -- Infinite Converts
	Infinite_Doc_Bag_Use = false, -- Infinite Doctor Bag Uses
	Infinite_ECM_Battery = false, -- Infinite ECM Battery
	Infinite_Messiah_Charge = false, -- Infinite Messiah Charge
	Infinite_Pager_Answers = false,  -- Infinite Pager Answer
	Infinite_Specials = false, -- Infinite Specials (Cable Ties, Planks, Etc)
	Instant_Dominate = false, -- Instant Dominate
	Instant_Drill = false, -- Instant Drill
	Instant_Interact = false, -- Instant Interact (Default 200)
	Instant_Interact_With_Anything = false, -- Interact With Anything
	Interact_Distance_Amount = 600, -- Interact Distance Increase Amount (Must Set For InGame Toggle)
	Interact_Distance_Increase = false, -- Interact Distance Increase
	Interact_Look_Around = false, -- Interact Look Around
	Interact_Thru_Wall = false, -- Interact Thru Wall
	No_Hit_Disorientation = false, -- No Hit Disorientation
	Small_Loot_Multiplier = false, -- Small Loot Multiplier (Host Only)
	Small_Loot_Multiplier_Amount = 3, -- Small Loot Multiplier Amount (Must Set For InGame Toggle)
	Zipline_Transport = false, -- Allow Attaching And Transport Of All Bags On All Zip-lines
	
	------------------------------
	-- WEAPON/CHANGER MENU (F2) --
	------------------------------
	-- WEAPON SETTINGS MENU OPTIONS --
	Weapon_Menu_Config = false, -- Weapon Settings Menu (Auto On Master Control)
	Sentry_God_Mode = false, -- Sentry Gun God Mode
	Sentry_Infinite_Ammo = false, -- Sentry God Infinite Ammo And No Recoil
	Weapon_Damage_Multiplier = false, -- Weapon Damage Multiplier
	Weapon_Damage_Multiplier_Amount = 500, -- Weapon Damage Multiplier Amount (Must Set For InGame Toggle) 
	Weapon_Fire_Rate_Multiplier = false, -- Weapon Fire Rate Multiplier  
	Weapon_Fire_Rate_Multiplier_Amount = 5000, -- Weapon Fire Rate Multiplier Amount (Must Set For InGame Toggle) 
	Weapon_Reload_Speed_Multiplier = false, -- Weapon Reload Speed Multiplier
	Weapon_Reload_Speed_Multiplier_Amount = 10, -- Weapon Reload Speed Multiplier Amount (Must Set For InGame Toggle) 
	Weapon_Swap_Speed_Multiplier = false, -- Weapon Swap Speed Multiplier
	Weapon_Swap_Speed_Multiplier_Amount = 1.8, -- Weapon Swap Speed Multiplier Amount (Must Set For InGame Toggle)
	
	-----------------------
	-- STEALTH MENU (F3) --
	-----------------------
	-- STEALTH MENU OPTIONS --
	Stealth_Menu_Config = false, -- Stealth Menu (Auto On Master Control)
	Cops_Dont_Shoot = false, -- Cops Dont Shoot At You (Host Only)
	Disable_Cameras = false, -- Disable All Cameras (Host Only)
	Disable_Pagers = false, -- Disable All Pagers (Host Only)
	Dont_Call_Police = false, -- Civilians/Guards Don't Call Police (Host Only)
	Free_Civ_Kills = false, -- Free Civilian Kills
	Lobotimize_AI = false, -- Lobotimize all AI (Host Only)
	No_Pager_Dominate = false, -- No Pager On Dominate (Host Only)
	No_Panic = false, -- No Panic Button or Intel Burn (Host Only)
	Random_Pagers = false, -- Make Pagers Random Making Some Guards Not Have Pagers (Host Only)
	Steal_Pagers = false, -- Steal Pagers When You Melee A Guard (Host Only)
	
	-----------------------------------
	-- MISSION MANIPULATOR MENU (F4) --
	-----------------------------------
	Mission_Manipulator_config = false, -- Mission Manipulator Menu (Auto On Master Control) (Does Not Affect Anti-Cheat Disable)
	
	-- ANTI-CHEAT DISABLER --
	Anti_Cheat_Disable = true, -- Disable Anti-Cheat (Auto On Master Control)
	
	-- MOUSE MODE MENU (SET MOUSE BINDS) (CAN HAVE ONLY ONE SETUP ON AT A TIME) 
	Mouse_Action_Config = false, -- Action Mouse Setup (Auto On Control)
	MouseSlowMo = SideButton1, -- Slow Motion aka Bullet Time Toggle
	MouseTeleport = MiddleMouseButton,	-- Teleport On Cross-hair 
	Mouse_Convert_Config = false, -- Convert Mouse Setup (Auto On Control)
	MouseConvert = MiddleMouseButton, -- Instant Convert Enemies In Cross-hair
	MouseTeleport1 = SideButton1, -- Teleport On Cross-hair
}